package somlib.som.descriptions;

public class ListFloatParameter {

  public float[] parameter=null;
  public String comment=null;

  public ListFloatParameter() {
    this.parameter=null;
    this.comment=null;
  }

  public ListFloatParameter(float parameter[], String comment) {
    this.parameter=parameter;
    this.comment=comment;
  }

  public ListFloatParameter(String init) {
    int index;
    if((index = init.indexOf("#")) > 0) {
      if(!init.substring(0, index).trim().toUpperCase().equals("VOID"))
        parameter = toField(init.substring(0, index).trim());
      comment = new String(init.substring(index+1).trim());
    } else {
      if(!init.trim().toUpperCase().equals("VOID"))
        parameter = toField(init);
//     comment = null;
    }
  }

  private float[] toField(String str) {
    java.util.StringTokenizer strtok=new java.util.StringTokenizer(str);
    float[] zurueck = new float[strtok.countTokens()];
    for(int i=0; i<zurueck.length; i++) {
      zurueck[i]=Float.parseFloat(strtok.nextToken());
    }
    return zurueck;
  }

  public void read(Float[] init) {
    parameter = new float[init.length];
    for(int i=0; i<init.length; i++)
      parameter[i] = init[i].floatValue();
  }

  public String toString() {
    java.lang.StringBuffer strbuf = new java.lang.StringBuffer();
    if(parameter!=null) {
      for(int i=0; i<parameter.length; i++)
        strbuf.append(" "+parameter[i]);
    } else
      strbuf.append(" VOID");
    if(comment!=null)
      strbuf.append(" #"+comment);
    return strbuf.toString();
  }

  public void writeTo(java.io.BufferedWriter out) throws java.io.IOException {
    if(parameter != null) {
      for(int i=0; i<parameter.length; i++)
        out.write(" "+parameter[i]);
    } else
      out.write(" VOID");
    if(comment!=null)
      out.write(" #"+comment);
  }

}
