package somlib.som.descriptions;

import java.io.*;

public class NodeItem {
/*
 * this class handles file communication for  SOM Unit Descriptions
 */

  /** Parameters:  **/
  public java.util.Vector unknown = null;
  public java.lang.StringBuffer comment = new java.lang.StringBuffer();
       //mandatory
  public IntegerParameter pos_x=new IntegerParameter();
  public IntegerParameter pos_y=new IntegerParameter();

        //optional
  public StringParameter unit_id=new StringParameter();
  public FloatParameter quanterror_unit=new FloatParameter();
  public FloatParameter quanterror_unit_avg=new FloatParameter();
  public FloatParameter umat_unit=new FloatParameter();
  public FloatParameter umat_right=new FloatParameter();
  public FloatParameter umat_down=new FloatParameter();
  public FloatParameter umat_down_left=new FloatParameter();
  public FloatParameter umat_down_right=new FloatParameter();
  public IntegerParameter nr_vec_mapped=new IntegerParameter();
  public StringParameter mapped_vecs=new StringParameter();
  public ListFloatParameter mapped_vecs_dist=new ListFloatParameter();
//  public int nr_soms_mapped=-1;
//  public String url_mapped_soms=null;
  public IntegerParameter nr_unit_labels=new IntegerParameter();
  public ListStringParameter unit_labels=new ListStringParameter();
  public ListFloatParameter unit_labels_qe=new ListFloatParameter();
  public ListFloatParameter unit_labels_wgt=new ListFloatParameter();
  public StringParameter description=new StringParameter();

  public NodeItem() {
    this.unknown = new java.util.Vector();
  }

  public boolean hasCoordinates(int x, int y) {
    if(pos_x.parameter==x && pos_y.parameter==y)
      return true;
    return false;
  }

  public void writeDescr(BufferedWriter out) throws IOException, DescriptionException {
      if(pos_x.parameter<0 || pos_y.parameter<0)
        throw new DescriptionException("Mandatory values aren't defined.");

      if(comment.length()>0)
        out.write(comment.toString());
      else {
        out.write("#-------------------------------"); out.newLine();
      }
      out.write("$POS_X"+pos_x.toString()); out.newLine();
      out.write("$POS_Y"+pos_y.toString()); out.newLine();
      if(unit_id.parameter!=null) {
        out.write("$UNIT_ID"+unit_id.toString()); out.newLine();
      }
      if(quanterror_unit.parameter!=-1) {
        out.write("$QUANTERROR_UNIT"+quanterror_unit.toString()); out.newLine();
      }
      if(quanterror_unit.parameter!=-1 && nr_vec_mapped.parameter!=-1) {
        quanterror_unit_avg.parameter = quanterror_unit_avg();
        out.write("$QUANTERROR_UNIT_AVG"+ quanterror_unit_avg.toString()); out.newLine();
      }
      if(umat_unit.parameter!=-1) {
        out.write("$UMAT_UNIT"+umat_unit.toString()); out.newLine();
      }
      if(umat_right.parameter!=-1) {
        out.write("$UMAT_RIGHT"+umat_right.toString()); out.newLine();
      }
      if(umat_down.parameter!=-1) {
        out.write("$UMAT_DOWN"+umat_down.toString()); out.newLine();
      }
      if(umat_down_left.parameter!=-1) {
        out.write("$UMAT_DOWN_LEFT"+umat_down_left.toString()); out.newLine();
      }
      if(umat_down_right.parameter!=-1) {
        out.write("$UMAT_DOWN_RIGHT"+umat_down_right.toString()); out.newLine();
      }
      if(nr_vec_mapped.parameter!=-1) {
        out.write("$NR_VEC_MAPPED"+nr_vec_mapped.toString()); out.newLine();
      }
      if(mapped_vecs.parameter!=null) {
        out.write("$MAPPED_VECS"+mapped_vecs.toString()); out.newLine();
      }
      if(mapped_vecs_dist.parameter!=null && mapped_vecs_dist.parameter.length>0) {
        out.write("$MAPPED_VECS_DIST");
        mapped_vecs_dist.writeTo(out);
        out.newLine();
      }
/*      if(nr_soms_mapped!=-1) {
        out.write("$NR_SOMS_MAPPED "+nr_soms_mapped); out.newLine();
      }
      if(url_mapped_soms!=null) {
        out.write("$URL_MAPPED_SOMS "+url_mapped_soms); out.newLine();
      }  */
      if(nr_unit_labels.parameter!=-1) {
        out.write("$NR_UNIT_LABELS"+nr_unit_labels.toString()); out.newLine();
      }
      if(unit_labels.parameter!=null) {
        out.write("$UNIT_LABELS");
        unit_labels.writeTo(out);
        out.newLine();
      }
      if(unit_labels_qe.parameter!=null) {
        out.write("$UNIT_LABELS_QE");
        unit_labels_qe.writeTo(out);
        out.newLine();
      }
      if(unit_labels_wgt.parameter!=null) {
        out.write("$UNIT_LABELS_WGT");
        unit_labels_wgt.writeTo(out);
        out.newLine();
      }
      if(description.parameter!=null) {
        out.write("$DESCRIPTION"+description.toString()); out.newLine();
      }
      for (java.util.Enumeration enum = unknown.elements(); enum.hasMoreElements(); ) {
        out.write((String)enum.nextElement()); out.newLine();
      }
  }

  public float quanterror_unit_avg() {
    if(quanterror_unit.parameter==-1 || nr_vec_mapped.parameter==-1)
      return -1;      /* Not all necessary parameters available to compute quanterror_unit_avg. */

    return (float) quanterror_unit.parameter / nr_vec_mapped.parameter;
  }

  public java.util.Vector mappedVecsDist()
  /*
   * the distances by which vectors are mapped onto the unit are returned
   */
  {
    if(nr_vec_mapped.parameter<=0)
      return new java.util.Vector();

    java.util.Vector zurueck = new java.util.Vector();
    for(int i=0; i<mapped_vecs_dist.parameter.length; i++)
      zurueck.add(new Float(mapped_vecs_dist.parameter[i]));
    return zurueck;
  }

}