package somlib.som.descriptions;

import java.io.*;

public class RGB {
/*
 * with this structure a color in the RGB-color-space is represented
 */

  public static RGB white() {
    try {
      return new RGB(255, 255, 255);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }

  public static RGB black() {
    try {
      return new RGB(0, 0, 0);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }

  public static RGB blue() {
    try {
      return new RGB(0, 0, 140);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }

  public static RGB red() {
    try {
      return new RGB(140, 0, 0);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }

  public static RGB green() {
    try {
      return new RGB(0, 140, 0);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }

  public static RGB grey() {
    try {
      return new RGB(140, 140, 140);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }

  public static RGB violet() {
    try {
      return new RGB(140, 0, 140);
    } catch(DescriptionException e) {} // this should never ever occur
    return null;
  }


  public int R = 0;
  public int G = 0;
  public int B = 0;

  public RGB(int R, int G, int B) throws DescriptionException {
    if(R < 0 || R > 255)
      throw new DescriptionException("RGB format exception: R is beyond bounds: "+R);
    if(G < 0 || G > 255)
      throw new DescriptionException("RGB format exception: G is beyond bounds: "+G);
    if(B < 0 || B > 255)
      throw new DescriptionException("RGB format exception: B is beyond bounds: "+B);

    this.R = R;
    this.G = G;
    this.B = B;
  }

  public RGB(String stoa) throws DescriptionException {
    java.util.StringTokenizer strtok = new java.util.StringTokenizer(stoa);
    R = Integer.parseInt(strtok.nextToken());
    G = Integer.parseInt(strtok.nextToken());
    B = Integer.parseInt(strtok.nextToken());

    if(R < 0 || R > 255)
      throw new DescriptionException("RGB format exception: R is beyond bounds: "+R);
    if(G < 0 || G > 255)
      throw new DescriptionException("RGB format exception: G is beyond bounds: "+G);
    if(B < 0 || B > 255)
      throw new DescriptionException("RGB format exception: B is beyond bounds: "+B);
  }

  public String toString() {
    return new String(R+" "+G+" "+B);
  }

}