package somlib.som.functions;

public class ELearn implements Learnrate
/*
 * an actual implementation of a Learnrate-Function;
 * the corresponding Neighborhood-Function is ELearn;
 * it is called by somlib.som.functions.Functions and chosen by a String-parameter containing "ELearn"
 */
{

  private float eps0;
  private float teps;

  public void define(int XDim, int YDim, float eps0)
  /*
   * as it is not possible to define a constructor (due to the way the class is instantiated)
   * the initialisation has to be done here
   */
  {
    this.eps0=eps0;
    float logbasis = (float) (Math.log((float) (XDim*YDim))*(1.0/Math.log(10.0))*50.0);
    teps = (float) Math.pow(logbasis, 2.0);
  }

  public float eps(int t) {
    return eps0* (float) Math.exp(-t / teps);
  }

  public String learnrateType() {
    String classname = this.getClass().getName();
    return classname.substring(classname.lastIndexOf('.')+1, classname.length());
  }

  public float learnrateInit() {
    return eps0;
  }

}