package somlib.som.preprocess;

import java.io.*;
import somlib.som.*;

public class VecReader extends Reader {

  public VecReader(String filename, somlib.textrepresentation.Logfile log, byte verbose) throws PreprocessException {
    super(filename, log, verbose);
  }

  public void initIVs(String filename) throws PreprocessException{
    if (verbose > 1) System.out.println("    start: initIV.");

    somlib.som.descriptions.VectorIn vec;
    try {
      vec = new somlib.som.descriptions.VectorIn(filename);
    } catch (somlib.som.descriptions.DescriptionException e) {
      throw new PreprocessException("Training.initIVs: "+e.getMessage());
    }
    this.type = vec.type;
    this.vecs = vec.XDim;
    this.dims = vec.vec_dim;
    this.iv = vec.vecs;
    this.labels = vec.labels;

    if (verbose > 1) System.out.println("    end: initIV.");
  }

}