package somlib.textrepresentation;

import java.io.*;
import java.util.*;
import java.lang.*;

/**
 *
 * @author elan
 * @version 1.0 (26.08.1999)
 */
public class CreateTemplate extends Object {

/**
 *  merge many wordlists to one
 *  @param inFiles individual wordlists that are used to create new template vector
 *  @param tv old (unreduced) template vector (if null then no old tv is loaded)
 *  @param verbose extra information is given
 *  @return new template vector
 *  @exception PreprocessException if any error occurs
 */
  public static Hashtable merge(File[] inFiles, Hashtable tv, byte verbose, Logfile l) throws TextrepresentationException {
    ObjectInputStream in;
    Hashtable idv;
    TemplateItem oldCount;

    int files=0; // zaehle inkludierte files (werden unter $files im tv gespeichert)

    if (inFiles==null)
      throw new TextrepresentationException("No Files to process given!");
    if (tv == null) tv = new Hashtable();
    if (verbose>0) System.out.println("  Start: CreateTemplate: Reading "+inFiles.length + " Files.");
    if (inFiles==null) {throw new TextrepresentationException("CreateTemplate: inFiles is null.");}
    try {
      for (int i = 0; i < inFiles.length; i++) {
        if (inFiles[i].isFile()) {

          if (verbose>2) System.out.println("    CreateTemplate: Reading: "+inFiles[i].toString());

          files++;
          in = new ObjectInputStream(new FileInputStream(inFiles[i]));
          idv = (Hashtable) in.readObject();
          in.close();

          oldCount = null;
          for (Enumeration enum = idv.keys(); enum.hasMoreElements(); ) {
            String key = (String) enum.nextElement();
            if ((oldCount = (TemplateItem) tv.get(key)) == null) {tv.put(key, new TemplateItem(((Integer)idv.get(key)).intValue()) );} // noch nicht vorhanden
            else {
              tv.remove(key);
              tv.put(key, oldCount.addtf( ((Integer)idv.get(key)).intValue() ) );   // anzahl der files die wort enthalten, gesamt vorkommnisse des wortes in allen files
            } // zaehler erhoehen
          }
        } // kein verzeichnis
      } // gehe alle files durch
    } catch (Exception e) {
      throw new TextrepresentationException("CreateTemplate: "+e.getMessage());
    }

    // anzahl der files mitspeichern
    Integer oldFiles;
    if ((oldFiles = (Integer) tv.get("$files")) == null) {tv.put(new String("$files"), new Integer(files));} // noch nicht vorhanden
    else {
      tv.remove("$files");
      tv.put(new String("$files"), new Integer(oldFiles.intValue()+files)); // anzahl der files
    }

    if (verbose > 0) System.out.println("  End: CreateTemplate.");

    return tv;
  } // merge
}
