package somlib.textrepresentation;

import java.io.*;
import java.util.*;
import java.lang.*;

/**
*
* @author elan
* @version 1.0 (26.08.1999)
*/
public class Reducer extends Object {

/**
 *  reduces the wordlist
 *  @param removedWordsFile if set to 'null' this will be ignored, otherwise the list of the removed words will be stored
 *  @param maxWordCount percentage, words that apear in more files then this limit are disgarded
 *  @param minWordCount percentage, words that apear in less files then this limit are disgarded
 *  @param tv old (unreduced) template vector
 *  @param verbose extra information is given
 *  @return new template vector
 *  @exception PreprocessException if any error occurs
 */
  public static Hashtable reduce(String removedWordsFile, int maxCount, int minCount, Hashtable tv, byte verbose, Logfile l) throws TextrepresentationException 
  {
    if(l!=null)
      l.append("Start: Reducer Module.");

    if (verbose > 0) System.out.println("  Reducer: start");

    if (tv != null) {
      Integer oldCount = null;
      TemplateItem count = null;
      if (verbose>1) System.out.println("    words: " + tv.size());
      if (verbose>1) System.out.println("    max limit: " + maxCount);
      if (verbose>1) System.out.println("    min limit: " + minCount);

      try {

      if (verbose>2) System.out.println("      Words:");


        if (removedWordsFile != null) { // save reduced.txt
          File remWords = new File(removedWordsFile);
          int pfad;
          if((pfad = remWords.toString().lastIndexOf(File.separator)) > 0) {
            File dirOfremWords = new File(remWords.toString().substring(0,pfad)); 
            dirOfremWords.mkdirs();
          }
          remWords.createNewFile();
          BufferedWriter out = new BufferedWriter(new FileWriter(remWords));
          for (Enumeration enum = tv.keys(); enum.hasMoreElements(); ) {
            String key = (String) enum.nextElement();
            if (key.substring(0,1).compareTo("$")!=0) {
              if (verbose>2) System.out.println("      "+key);
              count = (TemplateItem)tv.get(key);
              if (count.df  >= maxCount) {tv.remove(key); out.write("H " + count.toString() + " " + key); out.newLine();}
              else if (count.df  <= minCount) {tv.remove(key); out.write("L " + count.toString() + " " + key); out.newLine();}
            }
          }
          out.flush(); out.close();
        } else { // kein reduced words file anlegen.
          for (Enumeration enum = tv.keys(); enum.hasMoreElements(); ) {
            String key = (String) enum.nextElement();
            if (key.substring(0,1).compareTo("$")!=0) {
              count = (TemplateItem) tv.get(key);
              if (verbose>2) System.out.println("      "+key);
              if (count.df  >= maxCount) {tv.remove(key);}
              else if (count.df <= minCount) {tv.remove(key);}
            }
          }
        }
      } catch (Exception e) {throw new TextrepresentationException(e.getMessage());}
      if (verbose>1) System.out.println("    words - reduced: " + tv.size());
    }  // Template Vektor ist leer
    if (verbose>0) System.out.println("  Reducer: done.");

    if(l!=null)
      l.append("End: Reducer Module.");

    return tv;
  } // reduce

}
