package somlib.textrepresentation;

import java.util.*;
import java.io.*;
import java.lang.*;

public class ngramsexc {

  public static void main(String[] args) {
    if (args.length%2 == 1)
      usage();
    else {
      int param=0;
      int sizeN=3;
      boolean spaces_ngrams=false;
      boolean numbers_ngrams=false;
      String input_ngrams=null;
      String output_ngrams=null;
      int verbose=2;

      while(param < args.length) {      //getting the command-line parameters
        if((args[param].length()>2) || (args[param].charAt(0)!='-'))
          usage();

        switch(args[param].charAt(1)) {
          case 'p':
            if(args[++param].charAt(0) == 't')
              spaces_ngrams=true;
            break;
          case 'n':
            if(args[++param].charAt(0) == 't')
              numbers_ngrams=true;
            break;
          case 'i':
            input_ngrams = new String(args[++param]);
            break;
          case 'o':
            output_ngrams = new String(args[++param]);
            break;
          case 's':
            sizeN = (int)args[++param].charAt(0)-(int)'0';
            break;
          case 'v':
            verbose = (int)args[++param].charAt(0)-(int)'0';
            break;
          default:
            usage();
        }
        param++;
      }

      if(output_ngrams==null || input_ngrams==null)
        usage();

      ngrams(sizeN, spaces_ngrams, numbers_ngrams, input_ngrams, output_ngrams, verbose);
    }
  } //main

  static void usage() {
    System.out.println("Usage: somlib.textrepresentation.parser.ngramsexc -i <input_ngrams> -o <output_ngrams> -s <size_ngrams> -p <spaces [t/f]> -n <numbers [t/f]> [-v <verbosity>]");
    System.out.println("Default: size_ngrams=3; spaces=false; numbers=false");

    System.exit(1);
  }

  private static void ngrams(int sizeN, boolean spaces_ngrams, boolean numbers_ngrams, String input_ngrams, String output_ngrams, int verb) 
  {
    if (sizeN<=0) {
      System.out.println("ngrams with an n smaller than zero?");
      System.exit(-1);
    }
    File indir3 = null;
    if (input_ngrams.compareTo("") != 0) { // bei input steht etwas
      indir3 = new File(input_ngrams);
      if (!indir3.exists()) { // dir existiert nicht
        System.out.println("NGrams input directory does not exist.");
        System.exit(-1);
      }
    } else {
      System.out.println("NGrams input directory missing.");
      System.exit(-1);
    }
    File outdir3 = null;
    if (output_ngrams.compareTo("") != 0) { // bei output steht etwas
      outdir3 = new File(output_ngrams);
      if(verb>0) System.out.println("Creating directory: "+output_ngrams);
      outdir3.mkdirs();
    } else {
      System.out.println("NGrams output directory missing.");
      System.exit(-1);
    }
    try {
      File f1 = new File(input_ngrams);
      File[] fili1 = f1.listFiles();
      somlib.textrepresentation.parser.NGrams ngr = new somlib.textrepresentation.parser.NGrams(sizeN,numbers_ngrams,spaces_ngrams);
      ngr.createFiles(fili1,output_ngrams,(byte) verb,null,false,".idv");
    } catch (Exception e) {
      System.out.println("NGrams Error");
      System.exit(-1);
    }
  } // ngrams

}
