package somlib.textrepresentation;

import java.util.*;
import java.io.*;
import java.lang.*;

public class reducerexc 
{

  public static void main(String[] args) {
    if (args.length%2 == 1)
      usage();
    else {
      int param=0;
      String input_reducer=null;
      String output_reducer=null;
      String min_reducer=null;
      String max_reducer=null;
      String removed_reducer=new String("");
      int verbose=2;

      while(param < args.length) {      //getting the command-line parameters
        if((args[param].length()>2) || (args[param].charAt(0)!='-'))
          usage();

        switch(args[param].charAt(1)) {
          case 'i':
            input_reducer = new String(args[++param]);
            break;
          case 'o':
            output_reducer = new String(args[++param]);
            break;
          case 'n':
            min_reducer = new String(args[++param]);
            break;
          case 'x':
            max_reducer = new String(args[++param]);
            break;
          case 'r':
            removed_reducer = new String(args[++param]);
            break;
          case 'v':
            verbose = (int)args[++param].charAt(0)-(int)'0';
            break;
          default:
            usage();
        }
        param++;
      }

      if(input_reducer==null || output_reducer==null || min_reducer==null || max_reducer==null )
        usage();

      reducer(input_reducer, output_reducer, min_reducer, max_reducer, removed_reducer, verbose);
    }
  } //main

  static void usage() {
    System.out.println("Usage: somlib.textrepresentation.reducerexc -i <input_template> -o <output_reduced> -n <min_reducer> -x <max_reducer> [-r <removed_template>] [-v <verbosity>]");

    System.exit(1);
  }


  private static void reducer(String input_reducer, String output_reducer, String min_reducer, String max_reducer, String removed_reducer, int verb)
  {
    File indir6 = null;
    if (input_reducer.compareTo("") != 0) { // bei input steht etwas
      indir6 = new File(input_reducer);
      if (!indir6.exists()) { // dir existiert nicht
        System.out.println("Reducer input file does not exist.");
        System.exit(-1);
      }
    } else {
      System.out.println("Reducer input file missing.");
      System.exit(-1);
    }
    Hashtable tv = null;
    File tvf = null;
    if (input_reducer.compareTo("") != 0) {
      tvf = new File(input_reducer);
      try {
        tv = TemplateVector.load(input_reducer);
      } catch (Exception e) {
        System.out.println("Can not load 'Template Vector' (reducer).");
        System.exit(-1);
      }
    }
    File outdir6 = null;
    if (output_reducer.compareTo("") == 0) {
      System.out.println("Reducer output file missing.");
      System.exit(-1);
    }
    double minD =0.0;
    try {
      minD = (new Double(min_reducer)).doubleValue();
      if ((minD<0.0) || (minD>1.0)) {
        System.out.println("Weird minimum border: "+minD);
        System.exit(-1);
      }
    } catch (Exception e) {
      System.out.println("Minimum must be in [0.0-1.0] (reducer).");
      System.exit(-1);
    }
    double maxD =0.0;
    try {
      maxD = (new Double(max_reducer)).doubleValue();
      if ((maxD<0.0) || (maxD>1.0)) {
        System.out.println("Weird maximum border: "+maxD);
        System.exit(-1);
      }
    } catch (Exception e) {
        System.out.println("Maximum must be in [0.0-1.0] (reducer).");
        System.exit(-1);
    }
    if (minD >= maxD) {
      System.out.println("Maximum must be smaller than Minimum (reducer).");
      System.exit(-1);
    }
    try {
      Hashtable redTv = new Hashtable();
      if (verb >1) System.out.println("$files: "+((Integer)tv.get("$files")).intValue());
      int minCount = (int) (minD* ((Integer)tv.get("$files")).intValue());
      int maxCount = (int) (maxD* ((Integer)tv.get("$files")).intValue());
      if (removed_reducer.compareTo("")!=0) {
        redTv = Reducer.reduce(removed_reducer, maxCount, minCount, tv, (byte) verb, null);
      } else {
        redTv = Reducer.reduce(null, maxCount, minCount, tv, (byte)verb, null);
      }
//      TemplateVector.toTextFile(output_reducer+".tv.txt", redTv);
      TemplateVector.store(output_reducer,tv);
    } catch (Exception e) {
      System.out.println("Reducer Error raised: "+e.getMessage());
      System.exit(-1);
    }
  } // reducer

}
