package somlib.textrepresentation;

import java.util.*;
import java.io.*;
import java.lang.*;

public class templatevectorexc 
{

  public static void main(String[] args) {
    if (args.length%2 == 1)
      usage();
    else {
      int param=0;
      String input_template=null;
      String output_template=null;
      String old_template=new String("");
      int verbose=2;

      while(param < args.length) {      //getting the command-line parameters
        if((args[param].length()>2) || (args[param].charAt(0)!='-'))
          usage();

        switch(args[param].charAt(1)) {
          case 'i':
            input_template = new String(args[++param]);
            break;
          case 'o':
            output_template = new String(args[++param]);
            break;
          case 'a':
            old_template = new String(args[++param]);
            break;
          case 'v':
            verbose = (int)args[++param].charAt(0)-(int)'0';
            break;
          default:
            usage();
        }
        param++;
      }

      if(input_template==null || output_template==null)
        usage();

      template(input_template, output_template, old_template, verbose);
    }
  } //main

  static void usage() {
    System.out.println("Usage: somlib.textrepresentation.templatevectorexc -i <input_dir> -o <output_template> [-a <old_template>] [-v <verbosity>]");

    System.exit(1);
  }

  private static void template(String input_template, String output_template, String old_template, int verb)
  {
    File indir5 = null;
    if (input_template.compareTo("") != 0) { // bei input steht etwas
      indir5 = new File(input_template);
      if (!indir5.exists()) { // dir existiert nicht
        System.out.println("Create template vector input directory does not exist.");
        System.exit(-1);
      }
    } else {
      System.out.println("Create template vector input directory missing.");
      System.exit(-1);
    }
    Hashtable oldTV = null;
    File oldf = null;
    if (old_template.compareTo("") != 0) {
      oldf = new File(old_template);
      if (!oldf.exists()) { // dir existiert nicht
        System.out.println("Can not find 'Existing Template' (create template vector).");
        System.exit(-1);
      } else {
        System.out.println("  Using old template: "+old_template);
        try {
          oldTV = TemplateVector.load(old_template);
        } catch (Exception e) {
          System.out.println("Can not load 'Existing Template' (create template vector).");
          System.exit(-1);
        }
      }
    }
    File outdir5 = null;
    if (output_template.compareTo("") == 0) {
      System.out.println("Create template vector output file missing.");
      System.exit(-1);
    }
    try {
      File f3 = new File(input_template);
      File[] fili3 = f3.listFiles();
      TemplateVector.store(output_template,CreateTemplate.merge(fili3, oldTV, (byte)verb,null));
    } catch (Exception e) {
      System.out.println("Create Template Error: "+e.getMessage());
      System.exit(-1);
    }
  } // template

}