package somlib.textrepresentation;

import java.util.*;
import java.io.*;
import java.lang.*;

public class wordsexc {

  public static void main(String[] args) {
    if (args.length%2 == 1)
      usage();
    else {
      int param=0;
      String input_words=null;
      String output_words=null;
      int minLength=2;
      int verbose=2;

      while(param < args.length) {      //getting the command-line parameters
        if((args[param].length()>2) || (args[param].charAt(0)!='-'))
          usage();

        switch(args[param].charAt(1)) {
          case 'i':
            input_words = new String(args[++param]);
            break;
          case 'o':
            output_words = new String(args[++param]);
            break;
          case 'm':
            minLength = (int)args[++param].charAt(0)-(int)'0';
            break;
          case 'v':
            verbose = (int)args[++param].charAt(0)-(int)'0';
            break;
          default:
            usage();
        }
        param++;
      }

      if(output_words==null || input_words==null)
        usage();

      words(input_words, output_words, minLength, verbose);
    }
  } //main

  static void usage() {
    System.out.println("Usage: somlib.textrepresentation.parser.wordsexc -i <input_words> -o <output_words> -m <minLength> [-v <verbosity>]");
    System.out.println("Default: minLength=2");

    System.exit(1);
  }

  private static void words(String input_words, String output_words, int minLength, int verb) {
    File indir4 = null;
    if (input_words.compareTo("") != 0) { // bei input steht etwas
      indir4 = new File(input_words);
      if (!indir4.exists()) { // dir existiert nicht
        System.out.println("Words input directory does not exist.");
        System.exit(-1);
      }
    } else {
        System.out.println("Words input directory does not exist.");
        System.exit(-1);
    }
    File outdir4 = null;
    if (output_words.compareTo("") != 0) { // bei output steht etwas
      outdir4 = new File(output_words);
      if(verb>0) System.out.println("Creating directory: "+output_words);
      outdir4.mkdirs();
    } else {
      System.out.println("Words output directory missing.");
      System.exit(-1);
    }
    if (minLength<=1) {
      System.out.println("minimum length smaller than 1?");
      System.exit(-1);
    }
    try {
      somlib.textrepresentation.parser.Words pws = new somlib.textrepresentation.parser.Words(minLength);
      File f1b = new File(input_words);
      File[] fili1b = f1b.listFiles();
      pws.createFiles(fili1b,output_words,(byte) verb,null,false,".idv");
    } catch (Exception e) {
      System.out.println("Words Error");
      System.exit(-1);
    }
  } // words

}
