package somlib.ui;

/**
 *
 * @author elias
 * @version 1.0
 */
public class Parser extends javax.swing.JFrame {

  private Help h_ngrams;
  private Help h_words;
  private Help h_template;
  private Help h_reducer;
  private Help h_extractor;
  private Help h_all;
  private javax.swing.JFileChooser fc;

  /** Initializes the Form */
  public Parser() {
    initComponents ();
    pack ();
    try {
      h_ngrams = new Help(this, "ParserNGrams Help",false, this.getClass().getResource("/somlib/ui/helptext/ParserNGrams.txt").getFile());
    } catch (Exception e) {System.out.println("parser ngrams helpfile not found: "+e.getMessage()); help_ngrams.setEnabled(false);}
    try {
      h_words = new Help(this, "ParserWords Help",false, this.getClass().getResource("/somlib/ui/helptext/ParserWords.txt").getFile());
    } catch (Exception e) {System.out.println("parser words helpfile not found: "+e.getMessage()); help_words.setEnabled(false);}
    try {
      h_template = new Help(this, "CreateTemplateVector Help",false, this.getClass().getResource("/somlib/ui/helptext/CreateTemplateVector.txt").getFile());
    } catch (Exception e) {System.out.println("create template vector helpfile not found: "+e.getMessage()); help_template.setEnabled(false);}
    try {
      h_reducer = new Help(this, "Reducer Help",false, this.getClass().getResource("/somlib/ui/helptext/Reducer.txt").getFile());
    } catch (Exception e) {System.out.println("reducer helpfile not found: "+e.getMessage()); help_reducer.setEnabled(false);}
    try {
      h_extractor = new Help(this, "Extractor Help",false, this.getClass().getResource("/somlib/ui/helptext/Extractor.txt").getFile());
    } catch (Exception e) {System.out.println("extractor helpfile not found: "+e.getMessage()); help_extractor.setEnabled(false);}
    try {
      h_all = new Help(this, "Parser Help",false, this.getClass().getResource("/somlib/ui/helptext/Parser.txt").getFile());
    } catch (Exception e) {System.out.println("Parser helpfile not found: "+e.getMessage()); help.setEnabled(false);}
    fc = new javax.swing.JFileChooser();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    // This code was developed using a non-commercially licensed version of NetBeans Developer 2.x.
    // For details, see http://www.netbeans.com/non_commercial.html

    setTitle ("Textpreprocessing");
    addWindowListener (new java.awt.event.WindowAdapter () {
        public void windowClosing (java.awt.event.WindowEvent evt) {
          exitForm (evt);
        }
      }
    );
    getContentPane ().setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;

    jPanel27 = new javax.swing.JPanel ();
    jPanel27.setLayout (new javax.swing.BoxLayout (jPanel27, 1));

      jPanel1 = new javax.swing.JPanel ();
      jPanel1.setBorder (new javax.swing.border.EtchedBorder ());
      jPanel1.setLayout (new javax.swing.BoxLayout (jPanel1, 1));

        jPanel4 = new javax.swing.JPanel ();
        jPanel4.setPreferredSize (new java.awt.Dimension(666, 35));
        jPanel4.setMaximumSize (new java.awt.Dimension(666, 35));
        jPanel4.setBorder (new javax.swing.border.EtchedBorder ());
        jPanel4.setMinimumSize (new java.awt.Dimension(666, 35));
        jPanel4.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints2;

          jPanel44 = new javax.swing.JPanel ();
          jPanel44.setPreferredSize (new java.awt.Dimension(35, 27));
          jPanel44.setMaximumSize (new java.awt.Dimension(35, 27));
          jPanel44.setBorder (new javax.swing.border.EtchedBorder (0));
          jPanel44.setMinimumSize (new java.awt.Dimension(35, 27));
          jPanel44.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints3;

            jLabel20 = new javax.swing.JLabel ();
            jLabel20.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
            jLabel20.setText ("Aktiv");
            jLabel20.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            gridBagConstraints3 = new java.awt.GridBagConstraints ();
            jPanel44.add (jLabel20, gridBagConstraints3);

          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          jPanel4.add (jPanel44, gridBagConstraints2);

          jPanel43 = new javax.swing.JPanel ();
          jPanel43.setPreferredSize (new java.awt.Dimension(120, 27));
          jPanel43.setMaximumSize (new java.awt.Dimension(120, 27));
          jPanel43.setBorder (new javax.swing.border.EtchedBorder (0));
          jPanel43.setMinimumSize (new java.awt.Dimension(120, 27));
          jPanel43.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints4;

            jLabel9 = new javax.swing.JLabel ();
            jLabel9.setText ("Description");
            gridBagConstraints4 = new java.awt.GridBagConstraints ();
            jPanel43.add (jLabel9, gridBagConstraints4);

          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          jPanel4.add (jPanel43, gridBagConstraints2);

          jPanel92 = new javax.swing.JPanel ();
          jPanel92.setPreferredSize (new java.awt.Dimension(135, 27));
          jPanel92.setMaximumSize (new java.awt.Dimension(135, 27));
          jPanel92.setBorder (new javax.swing.border.EtchedBorder (0));
          jPanel92.setMinimumSize (new java.awt.Dimension(135, 27));
          jPanel92.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints5;

            jLabel31 = new javax.swing.JLabel ();
            jLabel31.setText ("Input");
            gridBagConstraints5 = new java.awt.GridBagConstraints ();
            jPanel92.add (jLabel31, gridBagConstraints5);

          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          jPanel4.add (jPanel92, gridBagConstraints2);

          jPanel93 = new javax.swing.JPanel ();
          jPanel93.setPreferredSize (new java.awt.Dimension(135, 27));
          jPanel93.setMaximumSize (new java.awt.Dimension(135, 27));
          jPanel93.setBorder (new javax.swing.border.EtchedBorder (0));
          jPanel93.setMinimumSize (new java.awt.Dimension(135, 27));
          jPanel93.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints6;

            jLabel32 = new javax.swing.JLabel ();
            jLabel32.setText ("Output");
            gridBagConstraints6 = new java.awt.GridBagConstraints ();
            jPanel93.add (jLabel32, gridBagConstraints6);

          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          jPanel4.add (jPanel93, gridBagConstraints2);

          jPanel94 = new javax.swing.JPanel ();
          jPanel94.setPreferredSize (new java.awt.Dimension(202, 27));
          jPanel94.setMaximumSize (new java.awt.Dimension(202, 27));
          jPanel94.setBorder (new javax.swing.border.EtchedBorder (0));
          jPanel94.setMinimumSize (new java.awt.Dimension(202, 27));
          jPanel94.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints7;

            jLabel33 = new javax.swing.JLabel ();
            jLabel33.setText ("Options");
            gridBagConstraints7 = new java.awt.GridBagConstraints ();
            jPanel94.add (jLabel33, gridBagConstraints7);

          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          jPanel4.add (jPanel94, gridBagConstraints2);

          jPanel95 = new javax.swing.JPanel ();
          jPanel95.setPreferredSize (new java.awt.Dimension(35, 27));
          jPanel95.setMaximumSize (new java.awt.Dimension(35, 27));
          jPanel95.setBorder (new javax.swing.border.EtchedBorder (0));
          jPanel95.setMinimumSize (new java.awt.Dimension(35, 27));
          jPanel95.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints8;

            jLabel34 = new javax.swing.JLabel ();
            jLabel34.setText ("Help");
            gridBagConstraints8 = new java.awt.GridBagConstraints ();
            jPanel95.add (jLabel34, gridBagConstraints8);

          gridBagConstraints2 = new java.awt.GridBagConstraints ();
          jPanel4.add (jPanel95, gridBagConstraints2);

        jPanel1.add (jPanel4);

        jPanel9 = new javax.swing.JPanel ();
        jPanel9.setPreferredSize (new java.awt.Dimension(666, 80));
        jPanel9.setMaximumSize (new java.awt.Dimension(666, 80));
        jPanel9.setBorder (new javax.swing.border.EtchedBorder ());
        jPanel9.setMinimumSize (new java.awt.Dimension(666, 80));
        jPanel9.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints9;

          jPanel96 = new javax.swing.JPanel ();
          jPanel96.setPreferredSize (new java.awt.Dimension(35, 60));
          jPanel96.setMaximumSize (new java.awt.Dimension(35, 60));
          jPanel96.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel96.setMinimumSize (new java.awt.Dimension(35, 60));
          jPanel96.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints10;

            aktiv_ngrams = new javax.swing.JCheckBox ();
            aktiv_ngrams.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            gridBagConstraints10 = new java.awt.GridBagConstraints ();
            jPanel96.add (aktiv_ngrams, gridBagConstraints10);

          gridBagConstraints9 = new java.awt.GridBagConstraints ();
          jPanel9.add (jPanel96, gridBagConstraints9);

          jPanel98 = new javax.swing.JPanel ();
          jPanel98.setPreferredSize (new java.awt.Dimension(120, 60));
          jPanel98.setMaximumSize (new java.awt.Dimension(120, 60));
          jPanel98.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel98.setMinimumSize (new java.awt.Dimension(120, 60));
          jPanel98.setLayout (new java.awt.FlowLayout ());

            jLabel11 = new javax.swing.JLabel ();
            jLabel11.setText ("Plaintext to ");
            jPanel98.add (jLabel11);

            jLabel36 = new javax.swing.JLabel ();
            jLabel36.setText ("n-grams");
            jPanel98.add (jLabel36);

          gridBagConstraints9 = new java.awt.GridBagConstraints ();
          jPanel9.add (jPanel98, gridBagConstraints9);

          jPanel86 = new javax.swing.JPanel ();
          jPanel86.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel86.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel86.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel86.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel86.setLayout (new javax.swing.BoxLayout (jPanel86, 1));

            jPanel84 = new javax.swing.JPanel ();
            jPanel84.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel21 = new javax.swing.JLabel ();
              jLabel21.setAlignmentY (0.0F);
              jLabel21.setText ("Plaintext Directory");
              jPanel84.add (jLabel21);

            jPanel86.add (jPanel84);

            jPanel85 = new javax.swing.JPanel ();
            jPanel85.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints11;

              input_ngrams = new javax.swing.JTextField ();
              input_ngrams.setPreferredSize (new java.awt.Dimension(105, 21));
              input_ngrams.setMaximumSize (new java.awt.Dimension(95, 21));
              input_ngrams.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints11 = new java.awt.GridBagConstraints ();
              jPanel85.add (input_ngrams, gridBagConstraints11);

              sIn_ngrams = new javax.swing.JButton ();
              sIn_ngrams.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sIn_ngrams.setPreferredSize (new java.awt.Dimension(21, 21));
              sIn_ngrams.setMaximumSize (new java.awt.Dimension(21, 21));
              sIn_ngrams.setBorder (new javax.swing.border.EtchedBorder ());
              sIn_ngrams.setMinimumSize (new java.awt.Dimension(21, 21));
              sIn_ngrams.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sIn_ngramsActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints11 = new java.awt.GridBagConstraints ();
              jPanel85.add (sIn_ngrams, gridBagConstraints11);

            jPanel86.add (jPanel85);

          gridBagConstraints9 = new java.awt.GridBagConstraints ();
          jPanel9.add (jPanel86, gridBagConstraints9);

          jPanel89 = new javax.swing.JPanel ();
          jPanel89.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel89.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel89.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel89.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel89.setLayout (new javax.swing.BoxLayout (jPanel89, 1));

            jPanel87 = new javax.swing.JPanel ();
            jPanel87.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel22 = new javax.swing.JLabel ();
              jLabel22.setAlignmentY (0.0F);
              jLabel22.setText ("n - grams");
              jPanel87.add (jLabel22);

            jPanel89.add (jPanel87);

            jPanel88 = new javax.swing.JPanel ();
            jPanel88.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints12;

              output_ngrams = new javax.swing.JTextField ();
              output_ngrams.setPreferredSize (new java.awt.Dimension(105, 21));
              output_ngrams.setMaximumSize (new java.awt.Dimension(95, 21));
              output_ngrams.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints12 = new java.awt.GridBagConstraints ();
              jPanel88.add (output_ngrams, gridBagConstraints12);

              sOut_ngrams = new javax.swing.JButton ();
              sOut_ngrams.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sOut_ngrams.setPreferredSize (new java.awt.Dimension(21, 21));
              sOut_ngrams.setMaximumSize (new java.awt.Dimension(21, 21));
              sOut_ngrams.setBorder (new javax.swing.border.EtchedBorder ());
              sOut_ngrams.setMinimumSize (new java.awt.Dimension(21, 21));
              sOut_ngrams.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sOut_ngramsActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints12 = new java.awt.GridBagConstraints ();
              jPanel88.add (sOut_ngrams, gridBagConstraints12);

            jPanel89.add (jPanel88);

          gridBagConstraints9 = new java.awt.GridBagConstraints ();
          jPanel9.add (jPanel89, gridBagConstraints9);

          jPanel91 = new javax.swing.JPanel ();
          jPanel91.setPreferredSize (new java.awt.Dimension(202, 60));
          jPanel91.setMaximumSize (new java.awt.Dimension(202, 58));
          jPanel91.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel91.setMinimumSize (new java.awt.Dimension(202, 58));
          jPanel91.setLayout (new javax.swing.BoxLayout (jPanel91, 0));

            jPanel14 = new javax.swing.JPanel ();
            jPanel14.setPreferredSize (new java.awt.Dimension(92, 21));
            jPanel14.setMaximumSize (new java.awt.Dimension(92, 21));
            jPanel14.setMinimumSize (new java.awt.Dimension(92, 21));
            jPanel14.setLayout (new java.awt.BorderLayout ());

              jPanel17 = new javax.swing.JPanel ();
              jPanel17.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints13;

                jLabel23 = new javax.swing.JLabel ();
                jLabel23.setText ("N [2-5] ");
                gridBagConstraints13 = new java.awt.GridBagConstraints ();
                jPanel17.add (jLabel23, gridBagConstraints13);

                sizeN_ngrams = new javax.swing.JTextField ();
                sizeN_ngrams.setPreferredSize (new java.awt.Dimension(21, 21));
                sizeN_ngrams.setMaximumSize (new java.awt.Dimension(21, 21));
                sizeN_ngrams.setText ("3");
                gridBagConstraints13 = new java.awt.GridBagConstraints ();
                jPanel17.add (sizeN_ngrams, gridBagConstraints13);

              jPanel14.add (jPanel17, "Center");

            jPanel91.add (jPanel14);

            jPanel16 = new javax.swing.JPanel ();
            jPanel16.setPreferredSize (new java.awt.Dimension(4, 100));
            jPanel16.setMinimumSize (new java.awt.Dimension(4, 60));
            jPanel16.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints14;

              jSeparator1 = new javax.swing.JSeparator ();
              jSeparator1.setPreferredSize (new java.awt.Dimension(2, 50));
              jSeparator1.setMaximumSize (new java.awt.Dimension(2, 0));
              jSeparator1.setOrientation (javax.swing.SwingConstants.VERTICAL);
              jSeparator1.setAlignmentX (0.0F);
              jSeparator1.setMinimumSize (new java.awt.Dimension(2, 0));
              gridBagConstraints14 = new java.awt.GridBagConstraints ();
              jPanel16.add (jSeparator1, gridBagConstraints14);

            jPanel91.add (jPanel16);

            jPanel19 = new javax.swing.JPanel ();
            jPanel19.setPreferredSize (new java.awt.Dimension(95, 140));
            jPanel19.setMaximumSize (new java.awt.Dimension(95, 140));
            jPanel19.setMinimumSize (new java.awt.Dimension(95, 140));
            jPanel19.setLayout (new javax.swing.BoxLayout (jPanel19, 0));

              jPanel20 = new javax.swing.JPanel ();
              jPanel20.setPreferredSize (new java.awt.Dimension(14, 10));
              jPanel20.setMaximumSize (new java.awt.Dimension(14, 10));
              jPanel20.setMinimumSize (new java.awt.Dimension(5, 10));
              jPanel20.setLayout (new java.awt.FlowLayout ());

              jPanel19.add (jPanel20);

              jPanel90 = new javax.swing.JPanel ();
              jPanel90.setPreferredSize (new java.awt.Dimension(82, 140));
              jPanel90.setMaximumSize (new java.awt.Dimension(84, 140));
              jPanel90.setMinimumSize (new java.awt.Dimension(84, 140));
              jPanel90.setLayout (new java.awt.BorderLayout ());

                jLabel24 = new javax.swing.JLabel ();
                jLabel24.setHorizontalTextPosition (javax.swing.SwingConstants.LEFT);
                jLabel24.setPreferredSize (new java.awt.Dimension(40, 17));
                jLabel24.setMaximumSize (new java.awt.Dimension(40, 17));
                jLabel24.setMinimumSize (new java.awt.Dimension(40, 17));
                jLabel24.setText ("Include");
                jLabel24.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
                jPanel90.add (jLabel24, "North");

                jPanel15 = new javax.swing.JPanel ();
                jPanel15.setPreferredSize (new java.awt.Dimension(120, 40));
                jPanel15.setMaximumSize (new java.awt.Dimension(120, 40));
                jPanel15.setMinimumSize (new java.awt.Dimension(120, 40));
                jPanel15.setLayout (new java.awt.GridLayout (2, 1));

                  numbers_ngrams = new javax.swing.JCheckBox ();
                  numbers_ngrams.setText ("Numbers");
                  jPanel15.add (numbers_ngrams);

                  spaces_ngrams = new javax.swing.JCheckBox ();
                  spaces_ngrams.setText ("Spaces");
                  jPanel15.add (spaces_ngrams);

                jPanel90.add (jPanel15, "South");

              jPanel19.add (jPanel90);

            jPanel91.add (jPanel19);

          gridBagConstraints9 = new java.awt.GridBagConstraints ();
          jPanel9.add (jPanel91, gridBagConstraints9);

          jPanel97 = new javax.swing.JPanel ();
          jPanel97.setPreferredSize (new java.awt.Dimension(35, 76));
          jPanel97.setMaximumSize (new java.awt.Dimension(35, 76));
          jPanel97.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel97.setMinimumSize (new java.awt.Dimension(35, 76));
          jPanel97.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints15;

            help_ngrams = new javax.swing.JButton ();
            help_ngrams.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/help.gif")));
            help_ngrams.setToolTipText ("Help");
            help_ngrams.setPreferredSize (new java.awt.Dimension(23, 23));
            help_ngrams.setBorder (new javax.swing.border.EtchedBorder ());
            help_ngrams.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  help_ngramsActionPerformed (evt);
                }
              }
            );
            gridBagConstraints15 = new java.awt.GridBagConstraints ();
            jPanel97.add (help_ngrams, gridBagConstraints15);

          gridBagConstraints9 = new java.awt.GridBagConstraints ();
          jPanel9.add (jPanel97, gridBagConstraints9);

        jPanel1.add (jPanel9);

        jPanel123 = new javax.swing.JPanel ();
        jPanel123.setPreferredSize (new java.awt.Dimension(666, 80));
        jPanel123.setMaximumSize (new java.awt.Dimension(666, 80));
        jPanel123.setBorder (new javax.swing.border.EtchedBorder ());
        jPanel123.setMinimumSize (new java.awt.Dimension(666, 80));
        jPanel123.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints16;

          jPanel8 = new javax.swing.JPanel ();
          jPanel8.setPreferredSize (new java.awt.Dimension(35, 60));
          jPanel8.setMaximumSize (new java.awt.Dimension(35, 60));
          jPanel8.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel8.setMinimumSize (new java.awt.Dimension(35, 60));
          jPanel8.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints17;

            aktiv_words = new javax.swing.JCheckBox ();
            aktiv_words.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            gridBagConstraints17 = new java.awt.GridBagConstraints ();
            jPanel8.add (aktiv_words, gridBagConstraints17);

          gridBagConstraints16 = new java.awt.GridBagConstraints ();
          jPanel123.add (jPanel8, gridBagConstraints16);

          jPanel79 = new javax.swing.JPanel ();
          jPanel79.setPreferredSize (new java.awt.Dimension(120, 60));
          jPanel79.setMaximumSize (new java.awt.Dimension(120, 60));
          jPanel79.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel79.setMinimumSize (new java.awt.Dimension(120, 60));
          jPanel79.setLayout (new java.awt.FlowLayout ());

            jLabel14 = new javax.swing.JLabel ();
            jLabel14.setText ("Plaintext to");
            jPanel79.add (jLabel14);

            jLabel41 = new javax.swing.JLabel ();
            jLabel41.setText ("Wordhistograms");
            jPanel79.add (jLabel41);

          gridBagConstraints16 = new java.awt.GridBagConstraints ();
          jPanel123.add (jPanel79, gridBagConstraints16);

          jPanel110 = new javax.swing.JPanel ();
          jPanel110.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel110.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel110.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel110.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel110.setLayout (new javax.swing.BoxLayout (jPanel110, 1));

            jPanel108 = new javax.swing.JPanel ();
            jPanel108.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel42 = new javax.swing.JLabel ();
              jLabel42.setAlignmentY (0.0F);
              jLabel42.setText ("Plaintext Directory");
              jPanel108.add (jLabel42);

            jPanel110.add (jPanel108);

            jPanel109 = new javax.swing.JPanel ();
            jPanel109.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints18;

              input_words = new javax.swing.JTextField ();
              input_words.setPreferredSize (new java.awt.Dimension(105, 21));
              input_words.setMaximumSize (new java.awt.Dimension(95, 21));
              input_words.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints18 = new java.awt.GridBagConstraints ();
              jPanel109.add (input_words, gridBagConstraints18);

              sIn_words = new javax.swing.JButton ();
              sIn_words.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sIn_words.setPreferredSize (new java.awt.Dimension(21, 21));
              sIn_words.setMaximumSize (new java.awt.Dimension(21, 21));
              sIn_words.setBorder (new javax.swing.border.EtchedBorder ());
              sIn_words.setMinimumSize (new java.awt.Dimension(21, 21));
              sIn_words.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sIn_wordsActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints18 = new java.awt.GridBagConstraints ();
              jPanel109.add (sIn_words, gridBagConstraints18);

            jPanel110.add (jPanel109);

          gridBagConstraints16 = new java.awt.GridBagConstraints ();
          jPanel123.add (jPanel110, gridBagConstraints16);

          jPanel113 = new javax.swing.JPanel ();
          jPanel113.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel113.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel113.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel113.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel113.setLayout (new javax.swing.BoxLayout (jPanel113, 1));

            jPanel111 = new javax.swing.JPanel ();
            jPanel111.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel43 = new javax.swing.JLabel ();
              jLabel43.setAlignmentY (0.0F);
              jLabel43.setText ("Word Histograms");
              jPanel111.add (jLabel43);

            jPanel113.add (jPanel111);

            jPanel112 = new javax.swing.JPanel ();
            jPanel112.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints19;

              output_words = new javax.swing.JTextField ();
              output_words.setPreferredSize (new java.awt.Dimension(105, 21));
              output_words.setMaximumSize (new java.awt.Dimension(95, 21));
              output_words.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints19 = new java.awt.GridBagConstraints ();
              jPanel112.add (output_words, gridBagConstraints19);

              sOut_words = new javax.swing.JButton ();
              sOut_words.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sOut_words.setPreferredSize (new java.awt.Dimension(21, 21));
              sOut_words.setMaximumSize (new java.awt.Dimension(21, 21));
              sOut_words.setBorder (new javax.swing.border.EtchedBorder ());
              sOut_words.setMinimumSize (new java.awt.Dimension(21, 21));
              sOut_words.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sOut_wordsActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints19 = new java.awt.GridBagConstraints ();
              jPanel112.add (sOut_words, gridBagConstraints19);

            jPanel113.add (jPanel112);

          gridBagConstraints16 = new java.awt.GridBagConstraints ();
          jPanel123.add (jPanel113, gridBagConstraints16);

          jPanel121 = new javax.swing.JPanel ();
          jPanel121.setPreferredSize (new java.awt.Dimension(202, 60));
          jPanel121.setMaximumSize (new java.awt.Dimension(202, 60));
          jPanel121.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel121.setMinimumSize (new java.awt.Dimension(202, 60));
          jPanel121.setLayout (new javax.swing.BoxLayout (jPanel121, 0));

            jPanel116 = new javax.swing.JPanel ();
            jPanel116.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints20;

              jLabel46 = new javax.swing.JLabel ();
              jLabel46.setText ("Minimum Word Length ");
              gridBagConstraints20 = new java.awt.GridBagConstraints ();
              jPanel116.add (jLabel46, gridBagConstraints20);

              minLength_words = new javax.swing.JTextField ();
              minLength_words.setPreferredSize (new java.awt.Dimension(20, 21));
              minLength_words.setMaximumSize (new java.awt.Dimension(2147483647, 21));
              minLength_words.setText ("2");
              gridBagConstraints20 = new java.awt.GridBagConstraints ();
              jPanel116.add (minLength_words, gridBagConstraints20);

            jPanel121.add (jPanel116);

          gridBagConstraints16 = new java.awt.GridBagConstraints ();
          jPanel123.add (jPanel121, gridBagConstraints16);

          jPanel122 = new javax.swing.JPanel ();
          jPanel122.setPreferredSize (new java.awt.Dimension(35, 76));
          jPanel122.setMaximumSize (new java.awt.Dimension(35, 76));
          jPanel122.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel122.setMinimumSize (new java.awt.Dimension(35, 76));
          jPanel122.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints21;

            help_words = new javax.swing.JButton ();
            help_words.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/help.gif")));
            help_words.setToolTipText ("Help");
            help_words.setPreferredSize (new java.awt.Dimension(23, 23));
            help_words.setBorder (new javax.swing.border.EtchedBorder ());
            help_words.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  help_wordsActionPerformed (evt);
                }
              }
            );
            gridBagConstraints21 = new java.awt.GridBagConstraints ();
            jPanel122.add (help_words, gridBagConstraints21);

          gridBagConstraints16 = new java.awt.GridBagConstraints ();
          jPanel123.add (jPanel122, gridBagConstraints16);

        jPanel1.add (jPanel123);

        jPanel62 = new javax.swing.JPanel ();
        jPanel62.setPreferredSize (new java.awt.Dimension(666, 80));
        jPanel62.setMaximumSize (new java.awt.Dimension(666, 80));
        jPanel62.setBorder (new javax.swing.border.EtchedBorder ());
        jPanel62.setMinimumSize (new java.awt.Dimension(666, 80));
        jPanel62.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints22;

          jPanel99 = new javax.swing.JPanel ();
          jPanel99.setPreferredSize (new java.awt.Dimension(35, 60));
          jPanel99.setMaximumSize (new java.awt.Dimension(35, 60));
          jPanel99.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel99.setMinimumSize (new java.awt.Dimension(35, 60));
          jPanel99.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints23;

            aktiv_template = new javax.swing.JCheckBox ();
            aktiv_template.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            gridBagConstraints23 = new java.awt.GridBagConstraints ();
            jPanel99.add (aktiv_template, gridBagConstraints23);

          gridBagConstraints22 = new java.awt.GridBagConstraints ();
          jPanel62.add (jPanel99, gridBagConstraints22);

          jPanel100 = new javax.swing.JPanel ();
          jPanel100.setPreferredSize (new java.awt.Dimension(120, 60));
          jPanel100.setMaximumSize (new java.awt.Dimension(120, 60));
          jPanel100.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel100.setMinimumSize (new java.awt.Dimension(120, 60));
          jPanel100.setLayout (new java.awt.FlowLayout ());

            jLabel12 = new javax.swing.JLabel ();
            jLabel12.setText ("Histograms to");
            jPanel100.add (jLabel12);

            jLabel37 = new javax.swing.JLabel ();
            jLabel37.setText ("Template Vector");
            jPanel100.add (jLabel37);

          gridBagConstraints22 = new java.awt.GridBagConstraints ();
          jPanel62.add (jPanel100, gridBagConstraints22);

          jPanel65 = new javax.swing.JPanel ();
          jPanel65.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel65.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel65.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel65.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel65.setLayout (new javax.swing.BoxLayout (jPanel65, 1));

            jPanel63 = new javax.swing.JPanel ();
            jPanel63.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel29 = new javax.swing.JLabel ();
              jLabel29.setAlignmentY (0.0F);
              jLabel29.setText ("Histograms");
              jPanel63.add (jLabel29);

            jPanel65.add (jPanel63);

            jPanel64 = new javax.swing.JPanel ();
            jPanel64.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints24;

              input_template = new javax.swing.JTextField ();
              input_template.setPreferredSize (new java.awt.Dimension(105, 21));
              input_template.setMaximumSize (new java.awt.Dimension(95, 21));
              input_template.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints24 = new java.awt.GridBagConstraints ();
              jPanel64.add (input_template, gridBagConstraints24);

              sIn_template = new javax.swing.JButton ();
              sIn_template.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sIn_template.setPreferredSize (new java.awt.Dimension(21, 21));
              sIn_template.setMaximumSize (new java.awt.Dimension(21, 21));
              sIn_template.setBorder (new javax.swing.border.EtchedBorder ());
              sIn_template.setMinimumSize (new java.awt.Dimension(21, 21));
              sIn_template.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sIn_templateActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints24 = new java.awt.GridBagConstraints ();
              jPanel64.add (sIn_template, gridBagConstraints24);

            jPanel65.add (jPanel64);

          gridBagConstraints22 = new java.awt.GridBagConstraints ();
          jPanel62.add (jPanel65, gridBagConstraints22);

          jPanel68 = new javax.swing.JPanel ();
          jPanel68.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel68.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel68.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel68.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel68.setLayout (new javax.swing.BoxLayout (jPanel68, 1));

            jPanel66 = new javax.swing.JPanel ();
            jPanel66.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel30 = new javax.swing.JLabel ();
              jLabel30.setAlignmentY (0.0F);
              jLabel30.setText ("Template Vector");
              jPanel66.add (jLabel30);

            jPanel68.add (jPanel66);

            jPanel67 = new javax.swing.JPanel ();
            jPanel67.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints25;

              output_template = new javax.swing.JTextField ();
              output_template.setPreferredSize (new java.awt.Dimension(105, 21));
              output_template.setMaximumSize (new java.awt.Dimension(95, 21));
              output_template.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints25 = new java.awt.GridBagConstraints ();
              jPanel67.add (output_template, gridBagConstraints25);

              sOut_template = new javax.swing.JButton ();
              sOut_template.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sOut_template.setPreferredSize (new java.awt.Dimension(21, 21));
              sOut_template.setMaximumSize (new java.awt.Dimension(21, 21));
              sOut_template.setBorder (new javax.swing.border.EtchedBorder ());
              sOut_template.setMinimumSize (new java.awt.Dimension(21, 21));
              sOut_template.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sOut_templateActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints25 = new java.awt.GridBagConstraints ();
              jPanel67.add (sOut_template, gridBagConstraints25);

            jPanel68.add (jPanel67);

          gridBagConstraints22 = new java.awt.GridBagConstraints ();
          jPanel62.add (jPanel68, gridBagConstraints22);

          jPanel72 = new javax.swing.JPanel ();
          jPanel72.setPreferredSize (new java.awt.Dimension(202, 60));
          jPanel72.setMaximumSize (new java.awt.Dimension(202, 60));
          jPanel72.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel72.setMinimumSize (new java.awt.Dimension(202, 60));
          jPanel72.setLayout (new javax.swing.BoxLayout (jPanel72, 1));

            jPanel70 = new javax.swing.JPanel ();
            jPanel70.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints26;

              jLabel44 = new javax.swing.JLabel ();
              jLabel44.setAlignmentY (0.0F);
              jLabel44.setText ("Based on Existing Template");
              gridBagConstraints26 = new java.awt.GridBagConstraints ();
              jPanel70.add (jLabel44, gridBagConstraints26);

            jPanel72.add (jPanel70);

            jPanel71 = new javax.swing.JPanel ();
            jPanel71.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints27;

              old_template = new javax.swing.JTextField ();
              old_template.setPreferredSize (new java.awt.Dimension(155, 21));
              old_template.setMaximumSize (new java.awt.Dimension(95, 21));
              old_template.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints27 = new java.awt.GridBagConstraints ();
              jPanel71.add (old_template, gridBagConstraints27);

              sOld_template = new javax.swing.JButton ();
              sOld_template.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sOld_template.setPreferredSize (new java.awt.Dimension(21, 21));
              sOld_template.setMaximumSize (new java.awt.Dimension(21, 21));
              sOld_template.setBorder (new javax.swing.border.EtchedBorder ());
              sOld_template.setMinimumSize (new java.awt.Dimension(21, 21));
              sOld_template.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sOld_templateActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints27 = new java.awt.GridBagConstraints ();
              jPanel71.add (sOld_template, gridBagConstraints27);

            jPanel72.add (jPanel71);

          gridBagConstraints22 = new java.awt.GridBagConstraints ();
          jPanel62.add (jPanel72, gridBagConstraints22);

          jPanel69 = new javax.swing.JPanel ();
          jPanel69.setPreferredSize (new java.awt.Dimension(35, 76));
          jPanel69.setMaximumSize (new java.awt.Dimension(35, 76));
          jPanel69.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel69.setMinimumSize (new java.awt.Dimension(35, 76));
          jPanel69.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints28;

            help_template = new javax.swing.JButton ();
            help_template.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/help.gif")));
            help_template.setToolTipText ("Help");
            help_template.setPreferredSize (new java.awt.Dimension(23, 23));
            help_template.setBorder (new javax.swing.border.EtchedBorder ());
            help_template.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  help_templateActionPerformed (evt);
                }
              }
            );
            gridBagConstraints28 = new java.awt.GridBagConstraints ();
            jPanel69.add (help_template, gridBagConstraints28);

          gridBagConstraints22 = new java.awt.GridBagConstraints ();
          jPanel62.add (jPanel69, gridBagConstraints22);

        jPanel1.add (jPanel62);

        jPanel11 = new javax.swing.JPanel ();
        jPanel11.setPreferredSize (new java.awt.Dimension(666, 80));
        jPanel11.setMaximumSize (new java.awt.Dimension(666, 80));
        jPanel11.setBorder (new javax.swing.border.EtchedBorder ());
        jPanel11.setMinimumSize (new java.awt.Dimension(666, 80));
        jPanel11.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints29;

          jPanel103 = new javax.swing.JPanel ();
          jPanel103.setPreferredSize (new java.awt.Dimension(35, 60));
          jPanel103.setMaximumSize (new java.awt.Dimension(35, 60));
          jPanel103.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel103.setMinimumSize (new java.awt.Dimension(35, 60));
          jPanel103.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints30;

            aktiv_reducer = new javax.swing.JCheckBox ();
            aktiv_reducer.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            gridBagConstraints30 = new java.awt.GridBagConstraints ();
            jPanel103.add (aktiv_reducer, gridBagConstraints30);

          gridBagConstraints29 = new java.awt.GridBagConstraints ();
          jPanel11.add (jPanel103, gridBagConstraints29);

          jPanel102 = new javax.swing.JPanel ();
          jPanel102.setPreferredSize (new java.awt.Dimension(120, 60));
          jPanel102.setMaximumSize (new java.awt.Dimension(120, 60));
          jPanel102.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel102.setMinimumSize (new java.awt.Dimension(120, 60));
          jPanel102.setLayout (new java.awt.FlowLayout ());

            jLabel38 = new javax.swing.JLabel ();
            jLabel38.setText ("Reduce");
            jPanel102.add (jLabel38);

            jLabel13 = new javax.swing.JLabel ();
            jLabel13.setText ("Template Vector");
            jPanel102.add (jLabel13);

          gridBagConstraints29 = new java.awt.GridBagConstraints ();
          jPanel11.add (jPanel102, gridBagConstraints29);

          jPanel50 = new javax.swing.JPanel ();
          jPanel50.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel50.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel50.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel50.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel50.setLayout (new javax.swing.BoxLayout (jPanel50, 1));

            jPanel48 = new javax.swing.JPanel ();
            jPanel48.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel25 = new javax.swing.JLabel ();
              jLabel25.setAlignmentY (0.0F);
              jLabel25.setText ("Template Vector");
              jPanel48.add (jLabel25);

            jPanel50.add (jPanel48);

            jPanel49 = new javax.swing.JPanel ();
            jPanel49.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints31;

              input_reducer = new javax.swing.JTextField ();
              input_reducer.setPreferredSize (new java.awt.Dimension(105, 21));
              input_reducer.setMaximumSize (new java.awt.Dimension(95, 21));
              input_reducer.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints31 = new java.awt.GridBagConstraints ();
              jPanel49.add (input_reducer, gridBagConstraints31);

              sIn_reducer = new javax.swing.JButton ();
              sIn_reducer.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sIn_reducer.setPreferredSize (new java.awt.Dimension(21, 21));
              sIn_reducer.setMaximumSize (new java.awt.Dimension(21, 21));
              sIn_reducer.setBorder (new javax.swing.border.EtchedBorder ());
              sIn_reducer.setMinimumSize (new java.awt.Dimension(21, 21));
              sIn_reducer.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sIn_reducerActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints31 = new java.awt.GridBagConstraints ();
              jPanel49.add (sIn_reducer, gridBagConstraints31);

            jPanel50.add (jPanel49);

          gridBagConstraints29 = new java.awt.GridBagConstraints ();
          jPanel11.add (jPanel50, gridBagConstraints29);

          jPanel53 = new javax.swing.JPanel ();
          jPanel53.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel53.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel53.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel53.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel53.setLayout (new javax.swing.BoxLayout (jPanel53, 1));

            jPanel51 = new javax.swing.JPanel ();
            jPanel51.setLayout (new java.awt.FlowLayout (0, 5, 5));

              jLabel26 = new javax.swing.JLabel ();
              jLabel26.setAlignmentY (0.0F);
              jLabel26.setText ("Reduced Vector");
              jPanel51.add (jLabel26);

            jPanel53.add (jPanel51);

            jPanel52 = new javax.swing.JPanel ();
            jPanel52.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints32;

              output_reducer = new javax.swing.JTextField ();
              output_reducer.setPreferredSize (new java.awt.Dimension(105, 21));
              output_reducer.setMaximumSize (new java.awt.Dimension(95, 21));
              output_reducer.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints32 = new java.awt.GridBagConstraints ();
              jPanel52.add (output_reducer, gridBagConstraints32);

              sOut_reducer = new javax.swing.JButton ();
              sOut_reducer.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sOut_reducer.setPreferredSize (new java.awt.Dimension(21, 21));
              sOut_reducer.setMaximumSize (new java.awt.Dimension(21, 21));
              sOut_reducer.setBorder (new javax.swing.border.EtchedBorder ());
              sOut_reducer.setMinimumSize (new java.awt.Dimension(21, 21));
              sOut_reducer.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sOut_reducerActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints32 = new java.awt.GridBagConstraints ();
              jPanel52.add (sOut_reducer, gridBagConstraints32);

            jPanel53.add (jPanel52);

          gridBagConstraints29 = new java.awt.GridBagConstraints ();
          jPanel11.add (jPanel53, gridBagConstraints29);

          jPanel60 = new javax.swing.JPanel ();
          jPanel60.setPreferredSize (new java.awt.Dimension(202, 60));
          jPanel60.setMaximumSize (new java.awt.Dimension(202, 60));
          jPanel60.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel60.setMinimumSize (new java.awt.Dimension(202, 60));
          jPanel60.setLayout (new javax.swing.BoxLayout (jPanel60, 0));

            jPanel56 = new javax.swing.JPanel ();
            jPanel56.setLayout (new javax.swing.BoxLayout (jPanel56, 1));

              jPanel54 = new javax.swing.JPanel ();
              jPanel54.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints33;

                jLabel27 = new javax.swing.JLabel ();
                jLabel27.setPreferredSize (new java.awt.Dimension(24, 17));
                jLabel27.setMaximumSize (new java.awt.Dimension(24, 17));
                jLabel27.setMinimumSize (new java.awt.Dimension(24, 17));
                jLabel27.setText ("Min ");
                gridBagConstraints33 = new java.awt.GridBagConstraints ();
                jPanel54.add (jLabel27, gridBagConstraints33);

                min_reducer = new javax.swing.JTextField ();
                min_reducer.setPreferredSize (new java.awt.Dimension(30, 21));
                min_reducer.setMaximumSize (new java.awt.Dimension(2147483647, 21));
                min_reducer.setText ("0.02");
                gridBagConstraints33 = new java.awt.GridBagConstraints ();
                jPanel54.add (min_reducer, gridBagConstraints33);

              jPanel56.add (jPanel54);

              jPanel55 = new javax.swing.JPanel ();
              jPanel55.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints34;

                jLabel28 = new javax.swing.JLabel ();
                jLabel28.setPreferredSize (new java.awt.Dimension(24, 17));
                jLabel28.setMaximumSize (new java.awt.Dimension(24, 17));
                jLabel28.setMinimumSize (new java.awt.Dimension(24, 17));
                jLabel28.setText ("Max");
                gridBagConstraints34 = new java.awt.GridBagConstraints ();
                jPanel55.add (jLabel28, gridBagConstraints34);

                max_reducer = new javax.swing.JTextField ();
                max_reducer.setPreferredSize (new java.awt.Dimension(30, 21));
                max_reducer.setMaximumSize (new java.awt.Dimension(2147483647, 21));
                max_reducer.setText ("0.80");
                gridBagConstraints34 = new java.awt.GridBagConstraints ();
                jPanel55.add (max_reducer, gridBagConstraints34);

              jPanel56.add (jPanel55);

            jPanel60.add (jPanel56);

            jPanel82 = new javax.swing.JPanel ();
            jPanel82.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints35;

              jSeparator8 = new javax.swing.JSeparator ();
              jSeparator8.setPreferredSize (new java.awt.Dimension(2, 50));
              jSeparator8.setMaximumSize (new java.awt.Dimension(2, 50));
              jSeparator8.setOrientation (javax.swing.SwingConstants.VERTICAL);
              jSeparator8.setMinimumSize (new java.awt.Dimension(2, 50));
              gridBagConstraints35 = new java.awt.GridBagConstraints ();
              jPanel82.add (jSeparator8, gridBagConstraints35);

            jPanel60.add (jPanel82);

            jPanel59 = new javax.swing.JPanel ();
            jPanel59.setLayout (new javax.swing.BoxLayout (jPanel59, 1));

              jPanel57 = new javax.swing.JPanel ();
              jPanel57.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints36;

                jLabel45 = new javax.swing.JLabel ();
                jLabel45.setText ("Save Removed");
                gridBagConstraints36 = new java.awt.GridBagConstraints ();
                jPanel57.add (jLabel45, gridBagConstraints36);

              jPanel59.add (jPanel57);

              jPanel58 = new javax.swing.JPanel ();
              jPanel58.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints37;

                removed_reducer = new javax.swing.JTextField ();
                removed_reducer.setPreferredSize (new java.awt.Dimension(90, 21));
                removed_reducer.setMaximumSize (new java.awt.Dimension(90, 21));
                removed_reducer.setMinimumSize (new java.awt.Dimension(90, 21));
                gridBagConstraints37 = new java.awt.GridBagConstraints ();
                jPanel58.add (removed_reducer, gridBagConstraints37);

                sRem_reducer = new javax.swing.JButton ();
                sRem_reducer.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
                sRem_reducer.setPreferredSize (new java.awt.Dimension(21, 21));
                sRem_reducer.setMaximumSize (new java.awt.Dimension(21, 21));
                sRem_reducer.setBorder (new javax.swing.border.EtchedBorder ());
                sRem_reducer.setMinimumSize (new java.awt.Dimension(21, 21));
                sRem_reducer.addActionListener (new java.awt.event.ActionListener () {
                    public void actionPerformed (java.awt.event.ActionEvent evt) {
                      sRem_reducerActionPerformed (evt);
                    }
                  }
                );
                gridBagConstraints37 = new java.awt.GridBagConstraints ();
                jPanel58.add (sRem_reducer, gridBagConstraints37);

              jPanel59.add (jPanel58);

            jPanel60.add (jPanel59);

          gridBagConstraints29 = new java.awt.GridBagConstraints ();
          jPanel11.add (jPanel60, gridBagConstraints29);

          jPanel61 = new javax.swing.JPanel ();
          jPanel61.setPreferredSize (new java.awt.Dimension(35, 76));
          jPanel61.setMaximumSize (new java.awt.Dimension(35, 76));
          jPanel61.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel61.setMinimumSize (new java.awt.Dimension(35, 76));
          jPanel61.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints38;

            help_reducer = new javax.swing.JButton ();
            help_reducer.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/help.gif")));
            help_reducer.setToolTipText ("Help");
            help_reducer.setPreferredSize (new java.awt.Dimension(23, 23));
            help_reducer.setBorder (new javax.swing.border.EtchedBorder ());
            help_reducer.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  help_reducerActionPerformed (evt);
                }
              }
            );
            gridBagConstraints38 = new java.awt.GridBagConstraints ();
            jPanel61.add (help_reducer, gridBagConstraints38);

          gridBagConstraints29 = new java.awt.GridBagConstraints ();
          jPanel11.add (jPanel61, gridBagConstraints29);

        jPanel1.add (jPanel11);

        jPanel10 = new javax.swing.JPanel ();
        jPanel10.setPreferredSize (new java.awt.Dimension(666, 80));
        jPanel10.setMaximumSize (new java.awt.Dimension(666, 80));
        jPanel10.setBorder (new javax.swing.border.EtchedBorder ());
        jPanel10.setMinimumSize (new java.awt.Dimension(666, 80));
        jPanel10.setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints39;

          jPanel101 = new javax.swing.JPanel ();
          jPanel101.setPreferredSize (new java.awt.Dimension(35, 60));
          jPanel101.setMaximumSize (new java.awt.Dimension(35, 60));
          jPanel101.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel101.setMinimumSize (new java.awt.Dimension(35, 60));
          jPanel101.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints40;

            aktiv_extractor = new javax.swing.JCheckBox ();
            aktiv_extractor.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            gridBagConstraints40 = new java.awt.GridBagConstraints ();
            jPanel101.add (aktiv_extractor, gridBagConstraints40);

          gridBagConstraints39 = new java.awt.GridBagConstraints ();
          jPanel10.add (jPanel101, gridBagConstraints39);

          jPanel104 = new javax.swing.JPanel ();
          jPanel104.setPreferredSize (new java.awt.Dimension(120, 60));
          jPanel104.setMaximumSize (new java.awt.Dimension(120, 60));
          jPanel104.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel104.setMinimumSize (new java.awt.Dimension(120, 60));
          jPanel104.setLayout (new java.awt.FlowLayout ());

            jLabel39 = new javax.swing.JLabel ();
            jLabel39.setText ("Extract");
            jLabel39.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            jPanel104.add (jLabel39);

            jLabel40 = new javax.swing.JLabel ();
            jLabel40.setText ("Individual Vectors");
            jLabel40.setHorizontalAlignment (javax.swing.SwingConstants.CENTER);
            jPanel104.add (jLabel40);

          gridBagConstraints39 = new java.awt.GridBagConstraints ();
          jPanel10.add (jPanel104, gridBagConstraints39);

          jPanel23 = new javax.swing.JPanel ();
          jPanel23.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel23.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel23.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel23.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel23.setLayout (new javax.swing.BoxLayout (jPanel23, 1));

            jPanel18 = new javax.swing.JPanel ();
            jPanel18.setLayout (new java.awt.FlowLayout (2, 5, 3));

              jLabel15 = new javax.swing.JLabel ();
              jLabel15.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
              jLabel15.setToolTipText ("Histograms");
              jLabel15.setAlignmentY (0.0F);
              jLabel15.setText ("Hgs");
              jLabel15.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
              jPanel18.add (jLabel15);

              jPanel3 = new javax.swing.JPanel ();
              jPanel3.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints41;

                input_hgs_extractor = new javax.swing.JTextField ();
                input_hgs_extractor.setPreferredSize (new java.awt.Dimension(70, 21));
                input_hgs_extractor.setMaximumSize (new java.awt.Dimension(70, 21));
                input_hgs_extractor.setMinimumSize (new java.awt.Dimension(70, 21));
                gridBagConstraints41 = new java.awt.GridBagConstraints ();
                jPanel3.add (input_hgs_extractor, gridBagConstraints41);

                sHgs_extractor = new javax.swing.JButton ();
                sHgs_extractor.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
                sHgs_extractor.setPreferredSize (new java.awt.Dimension(21, 21));
                sHgs_extractor.setMaximumSize (new java.awt.Dimension(21, 21));
                sHgs_extractor.setBorder (new javax.swing.border.EtchedBorder ());
                sHgs_extractor.setMinimumSize (new java.awt.Dimension(21, 21));
                sHgs_extractor.addActionListener (new java.awt.event.ActionListener () {
                    public void actionPerformed (java.awt.event.ActionEvent evt) {
                      sHgs_extractorActionPerformed (evt);
                    }
                  }
                );
                gridBagConstraints41 = new java.awt.GridBagConstraints ();
                jPanel3.add (sHgs_extractor, gridBagConstraints41);

              jPanel18.add (jPanel3);

            jPanel23.add (jPanel18);

            jPanel22 = new javax.swing.JPanel ();
            jPanel22.setLayout (new java.awt.FlowLayout (2, 5, 0));

              jLabel16 = new javax.swing.JLabel ();
              jLabel16.setHorizontalTextPosition (javax.swing.SwingConstants.CENTER);
              jLabel16.setToolTipText ("Template Vector");
              jLabel16.setText ("TV");
              jLabel16.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
              jPanel22.add (jLabel16);

              jPanel21 = new javax.swing.JPanel ();
              jPanel21.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints42;

                input_tv_extractor = new javax.swing.JTextField ();
                input_tv_extractor.setPreferredSize (new java.awt.Dimension(70, 21));
                input_tv_extractor.setMaximumSize (new java.awt.Dimension(70, 21));
                input_tv_extractor.setMinimumSize (new java.awt.Dimension(70, 21));
                gridBagConstraints42 = new java.awt.GridBagConstraints ();
                jPanel21.add (input_tv_extractor, gridBagConstraints42);

                sTv_extractor = new javax.swing.JButton ();
                sTv_extractor.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
                sTv_extractor.setPreferredSize (new java.awt.Dimension(21, 21));
                sTv_extractor.setMaximumSize (new java.awt.Dimension(21, 21));
                sTv_extractor.setBorder (new javax.swing.border.EtchedBorder ());
                sTv_extractor.setMinimumSize (new java.awt.Dimension(21, 21));
                sTv_extractor.addActionListener (new java.awt.event.ActionListener () {
                    public void actionPerformed (java.awt.event.ActionEvent evt) {
                      sTv_extractorActionPerformed (evt);
                    }
                  }
                );
                gridBagConstraints42 = new java.awt.GridBagConstraints ();
                jPanel21.add (sTv_extractor, gridBagConstraints42);

              jPanel22.add (jPanel21);

            jPanel23.add (jPanel22);

          gridBagConstraints39 = new java.awt.GridBagConstraints ();
          jPanel10.add (jPanel23, gridBagConstraints39);

          jPanel29 = new javax.swing.JPanel ();
          jPanel29.setPreferredSize (new java.awt.Dimension(135, 60));
          jPanel29.setMaximumSize (new java.awt.Dimension(135, 60));
          jPanel29.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel29.setMinimumSize (new java.awt.Dimension(135, 60));
          jPanel29.setLayout (new javax.swing.BoxLayout (jPanel29, 1));

            jPanel26 = new javax.swing.JPanel ();
            jPanel26.setLayout (new javax.swing.BoxLayout (jPanel26, 0));

              jPanel25 = new javax.swing.JPanel ();
              jPanel25.setLayout (new java.awt.FlowLayout ());

                jLabel17 = new javax.swing.JLabel ();
                jLabel17.setAlignmentY (0.0F);
                jLabel17.setText ("Individual Vectors File");
                jPanel25.add (jLabel17);

              jPanel26.add (jPanel25);

            jPanel29.add (jPanel26);

            jPanel28 = new javax.swing.JPanel ();
            jPanel28.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints43;

              output_extractor = new javax.swing.JTextField ();
              output_extractor.setPreferredSize (new java.awt.Dimension(105, 21));
              output_extractor.setMaximumSize (new java.awt.Dimension(95, 21));
              output_extractor.setMinimumSize (new java.awt.Dimension(95, 21));
              gridBagConstraints43 = new java.awt.GridBagConstraints ();
              jPanel28.add (output_extractor, gridBagConstraints43);

              sOut = new javax.swing.JButton ();
              sOut.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
              sOut.setPreferredSize (new java.awt.Dimension(21, 21));
              sOut.setMaximumSize (new java.awt.Dimension(21, 21));
              sOut.setBorder (new javax.swing.border.EtchedBorder ());
              sOut.setMinimumSize (new java.awt.Dimension(21, 21));
              sOut.addActionListener (new java.awt.event.ActionListener () {
                  public void actionPerformed (java.awt.event.ActionEvent evt) {
                    sOutActionPerformed (evt);
                  }
                }
              );
              gridBagConstraints43 = new java.awt.GridBagConstraints ();
              jPanel28.add (sOut, gridBagConstraints43);

            jPanel29.add (jPanel28);

          gridBagConstraints39 = new java.awt.GridBagConstraints ();
          jPanel10.add (jPanel29, gridBagConstraints39);

          jPanel32 = new javax.swing.JPanel ();
          jPanel32.setPreferredSize (new java.awt.Dimension(202, 60));
          jPanel32.setMaximumSize (new java.awt.Dimension(202, 60));
          jPanel32.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel32.setMinimumSize (new java.awt.Dimension(202, 60));
          jPanel32.setLayout (new javax.swing.BoxLayout (jPanel32, 0));

            jPanel30 = new javax.swing.JPanel ();
            jPanel30.setLayout (new java.awt.FlowLayout ());

              jLabel18 = new javax.swing.JLabel ();
              jLabel18.setText ("Save as");
              jPanel30.add (jLabel18);

            jPanel32.add (jPanel30);

            jPanel31 = new javax.swing.JPanel ();
            jPanel31.setLayout (new java.awt.GridLayout (3, 1));

              chkTF_extractor = new javax.swing.JCheckBox ();
              chkTF_extractor.setText ("TF (*.tf)");
              jPanel31.add (chkTF_extractor);

              chkTFxIDF_extractor = new javax.swing.JCheckBox ();
              chkTFxIDF_extractor.setSelected (true);
              chkTFxIDF_extractor.setText ("TF x IDF (*.tfxidf)");
              jPanel31.add (chkTFxIDF_extractor);

              chkBin_extractor = new javax.swing.JCheckBox ();
              chkBin_extractor.setText ("Binary (*.bin)");
              jPanel31.add (chkBin_extractor);

            jPanel32.add (jPanel31);

          gridBagConstraints39 = new java.awt.GridBagConstraints ();
          jPanel10.add (jPanel32, gridBagConstraints39);

          jPanel45 = new javax.swing.JPanel ();
          jPanel45.setPreferredSize (new java.awt.Dimension(35, 76));
          jPanel45.setMaximumSize (new java.awt.Dimension(35, 76));
          jPanel45.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
          jPanel45.setMinimumSize (new java.awt.Dimension(35, 76));
          jPanel45.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints44;

            help_extractor = new javax.swing.JButton ();
            help_extractor.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/help.gif")));
            help_extractor.setToolTipText ("Help");
            help_extractor.setPreferredSize (new java.awt.Dimension(23, 23));
            help_extractor.setBorder (new javax.swing.border.EtchedBorder ());
            help_extractor.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  help_extractorActionPerformed (evt);
                }
              }
            );
            gridBagConstraints44 = new java.awt.GridBagConstraints ();
            jPanel45.add (help_extractor, gridBagConstraints44);

          gridBagConstraints39 = new java.awt.GridBagConstraints ();
          jPanel10.add (jPanel45, gridBagConstraints39);

        jPanel1.add (jPanel10);

      jPanel27.add (jPanel1);

      jPanel2 = new javax.swing.JPanel ();
      jPanel2.setBorder (new javax.swing.border.EmptyBorder (new java.awt.Insets(1, 1, 1, 1)));
      jPanel2.setLayout (new javax.swing.BoxLayout (jPanel2, 0));

        jPanel24 = new javax.swing.JPanel ();
        jPanel24.setLayout (new java.awt.FlowLayout ());

          jPanel106 = new javax.swing.JPanel ();
          jPanel106.setPreferredSize (new java.awt.Dimension(177, 35));
          jPanel106.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel106.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints45;

            jPanel80 = new javax.swing.JPanel ();
            jPanel80.setLayout (new java.awt.GridBagLayout ());
            java.awt.GridBagConstraints gridBagConstraints46;

              jPanel12 = new javax.swing.JPanel ();
              jPanel12.setLayout (new java.awt.FlowLayout ());

                jLabel6 = new javax.swing.JLabel ();
                jLabel6.setAlignmentY (0.0F);
                jLabel6.setText ("Logfile");
                jPanel12.add (jLabel6);

              gridBagConstraints46 = new java.awt.GridBagConstraints ();
              jPanel80.add (jPanel12, gridBagConstraints46);

              jPanel13 = new javax.swing.JPanel ();
              jPanel13.setLayout (new java.awt.GridBagLayout ());
              java.awt.GridBagConstraints gridBagConstraints47;

                logfile = new javax.swing.JTextField ();
                logfile.setPreferredSize (new java.awt.Dimension(95, 21));
                logfile.setMaximumSize (new java.awt.Dimension(95, 21));
                logfile.setMinimumSize (new java.awt.Dimension(95, 21));
                gridBagConstraints47 = new java.awt.GridBagConstraints ();
                jPanel13.add (logfile, gridBagConstraints47);

                sLog = new javax.swing.JButton ();
                sLog.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/search.gif")));
                sLog.setPreferredSize (new java.awt.Dimension(21, 21));
                sLog.setMaximumSize (new java.awt.Dimension(21, 21));
                sLog.setBorder (new javax.swing.border.EtchedBorder ());
                sLog.setMinimumSize (new java.awt.Dimension(21, 21));
                sLog.addActionListener (new java.awt.event.ActionListener () {
                    public void actionPerformed (java.awt.event.ActionEvent evt) {
                      sLogActionPerformed (evt);
                    }
                  }
                );
                gridBagConstraints47 = new java.awt.GridBagConstraints ();
                jPanel13.add (sLog, gridBagConstraints47);

              gridBagConstraints46 = new java.awt.GridBagConstraints ();
              jPanel80.add (jPanel13, gridBagConstraints46);

            gridBagConstraints45 = new java.awt.GridBagConstraints ();
            jPanel106.add (jPanel80, gridBagConstraints45);

          jPanel24.add (jPanel106);

          jPanel107 = new javax.swing.JPanel ();
          jPanel107.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel107.setLayout (new java.awt.FlowLayout ());

            jLabel5 = new javax.swing.JLabel ();
            jLabel5.setText ("Verbosity [0-3] ");
            jPanel107.add (jLabel5);

            verbose = new javax.swing.JTextField ();
            verbose.setPreferredSize (new java.awt.Dimension(21, 21));
            verbose.setMinimumSize (new java.awt.Dimension(21, 21));
            verbose.setText ("1");
            jPanel107.add (verbose);

          jPanel24.add (jPanel107);

          jPanel83 = new javax.swing.JPanel ();
          jPanel83.setPreferredSize (new java.awt.Dimension(110, 35));
          jPanel83.setBorder (new javax.swing.border.EtchedBorder ());
          jPanel83.setLayout (new java.awt.GridBagLayout ());
          java.awt.GridBagConstraints gridBagConstraints48;

            jLabel35 = new javax.swing.JLabel ();
            jLabel35.setText ("Settings ");
            gridBagConstraints48 = new java.awt.GridBagConstraints ();
            jPanel83.add (jLabel35, gridBagConstraints48);

            open = new javax.swing.JButton ();
            open.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/open.gif")));
            open.setToolTipText ("Load");
            open.setPreferredSize (new java.awt.Dimension(23, 23));
            open.setBorder (new javax.swing.border.EtchedBorder ());
            open.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  openActionPerformed (evt);
                }
              }
            );
            gridBagConstraints48 = new java.awt.GridBagConstraints ();
            jPanel83.add (open, gridBagConstraints48);

            save = new javax.swing.JButton ();
            save.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/save.gif")));
            save.setToolTipText ("Save");
            save.setPreferredSize (new java.awt.Dimension(23, 23));
            save.setBorder (new javax.swing.border.EtchedBorder ());
            save.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  saveActionPerformed (evt);
                }
              }
            );
            gridBagConstraints48 = new java.awt.GridBagConstraints ();
            jPanel83.add (save, gridBagConstraints48);

          jPanel24.add (jPanel83);

          jPanel105 = new javax.swing.JPanel ();
          jPanel105.setLayout (new java.awt.FlowLayout ());

            help = new javax.swing.JButton ();
            help.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/help.gif")));
            help.setToolTipText ("Help");
            help.setPreferredSize (new java.awt.Dimension(23, 23));
            help.setBorder (new javax.swing.border.EtchedBorder ());
            help.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  helpActionPerformed (evt);
                }
              }
            );
            jPanel105.add (help);

            run = new javax.swing.JButton ();
            run.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/run.gif")));
            run.setToolTipText ("Run");
            run.setPreferredSize (new java.awt.Dimension(23, 23));
            run.setMaximumSize (new java.awt.Dimension(23, 23));
            run.setBorder (new javax.swing.border.EtchedBorder ());
            run.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  runActionPerformed (evt);
                }
              }
            );
            jPanel105.add (run);

            quit = new javax.swing.JButton ();
            quit.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/somlib/ui/icons/quit.gif")));
            quit.setToolTipText ("Quit");
            quit.setPreferredSize (new java.awt.Dimension(23, 23));
            quit.setMaximumSize (new java.awt.Dimension(23, 23));
            quit.setBorder (new javax.swing.border.EtchedBorder ());
            quit.addActionListener (new java.awt.event.ActionListener () {
                public void actionPerformed (java.awt.event.ActionEvent evt) {
                  quitActionPerformed (evt);
                }
              }
            );
            jPanel105.add (quit);

          jPanel24.add (jPanel105);

        jPanel2.add (jPanel24);

      jPanel27.add (jPanel2);

    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    getContentPane ().add (jPanel27, gridBagConstraints1);

  }//GEN-END:initComponents

  private void openActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      if (file.exists()) {
       try {

        ConfigFileManager cfm = new ConfigFileManager(file.toString());

// ngrams
        sizeN_ngrams.setText(cfm.get("parserNgrams_options_n"));
        if (cfm.get("parserNgrams_options_numbers").compareTo("0") == 0) numbers_ngrams.setSelected(false);
        else numbers_ngrams.setSelected(true);
        if (cfm.get("parserNgrams_options_spaces").compareTo("0") == 0) spaces_ngrams.setSelected(false);
        else spaces_ngrams.setSelected(true);
        input_ngrams.setText(cfm.get("parserNgrams_input"));
        output_ngrams.setText(cfm.get("parserNgrams_ouput"));

// words
        minLength_words.setText(cfm.get("parserWords_options_minLength"));
        input_words.setText(cfm.get("parserWords_input"));
        output_words.setText(cfm.get("parserWords_ouput"));

// template
        old_template.setText(cfm.get("createTemplateVector_options_old"));
        input_template.setText(cfm.get("createTemplateVector_input"));
        output_template.setText(cfm.get("createTemplateVector_ouput"));

// reducer
        min_reducer.setText(cfm.get("reducer_options_min"));
        max_reducer.setText(cfm.get("reducer_options_max"));
        removed_reducer.setText(cfm.get("reducer_options_removed"));
        input_reducer.setText(cfm.get("reducer_input"));
        output_reducer.setText(cfm.get("reducer_ouput"));

// extractor
        if (cfm.get("extractor_options_TF").compareTo("0") == 0) chkTF_extractor.setSelected(false);
        else chkTF_extractor.setSelected(true);
        if (cfm.get("extractor_options_TFxIDF").compareTo("0") == 0) chkTFxIDF_extractor.setSelected(false);
        else chkTFxIDF_extractor.setSelected(true);
        if (cfm.get("extractor_options_bin").compareTo("0") == 0) chkBin_extractor.setSelected(false);
        else chkBin_extractor.setSelected(true);
        input_hgs_extractor.setText(cfm.get("extractor_input_hgs"));
        input_tv_extractor.setText(cfm.get("extractor_input_tv"));
        output_extractor.setText(cfm.get("extractor_ouput"));

// all
        verbose.setText(cfm.get("all_verbose"));
        logfile.setText(cfm.get("all_logfile"));
        if (cfm.get("aktiv_ngrams").compareTo("0") == 0) chkTF_extractor.setSelected(false);
        else aktiv_ngrams.setSelected(true);
        if (cfm.get("aktiv_words").compareTo("0") == 0) chkTF_extractor.setSelected(false);
        else aktiv_words.setSelected(true);
        if (cfm.get("aktiv_template").compareTo("0") == 0) chkTF_extractor.setSelected(false);
        else aktiv_template.setSelected(true);
        if (cfm.get("aktiv_reducer").compareTo("0") == 0) chkTF_extractor.setSelected(false);
        else aktiv_reducer.setSelected(true);
        if (cfm.get("aktiv_extractor").compareTo("0") == 0) chkTF_extractor.setSelected(false);
        else aktiv_extractor.setSelected(true);

       } catch (Exception e) {
         System.out.println("error open config: "+e.getMessage());
       }
      } else {
        javax.swing.JOptionPane.showMessageDialog(this, "File does not exist.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      }
    }

   // LOAD
  }//GEN-LAST:event_openActionPerformed

  private void saveActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveActionPerformed
    try {
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showSaveDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      if (!file.exists()) {
          Object[] options = {"Yes", "No"};
          int n = javax.swing.JOptionPane.showOptionDialog(this,"Configfile does not exists. Create new file?", "Create File", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
          if (n == javax.swing.JOptionPane.YES_OPTION) try {
            java.io.File dir = new java.io.File(file.toString().substring(0,file.toString().lastIndexOf(java.io.File.separator)));
            dir.mkdirs(); file.createNewFile();
          } catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, "Cannot create file.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
            throw new java.io.IOException();
          }
          else throw new java.io.IOException();
      }
      try {
        ConfigFileManager cfm = new ConfigFileManager(file.toString());

// ngrams
        cfm.set("parserNgrams_input",input_ngrams.getText());
        cfm.set("parserNgrams_ouput",output_ngrams.getText());
        cfm.set("parserNgrams_options_n",sizeN_ngrams.getText());
        if (numbers_ngrams.isSelected()) cfm.set("parserNgrams_options_numbers","1");
        else cfm.set("parserNgrams_options_numbers","0");
        if (spaces_ngrams.isSelected()) cfm.set("parserNgrams_options_spaces","1");
        else cfm.set("parserNgrams_options_spaces","0");

// words
        cfm.set("parserWords_input",input_words.getText());
        cfm.set("parserWords_ouput",output_words.getText());
        cfm.set("parserWords_options_minLength",minLength_words.getText());

// template
        cfm.set("createTemplateVector_input",input_template.getText());
        cfm.set("createTemplateVector_ouput",output_template.getText());
        cfm.set("createTemplateVector_options_old",old_template.getText());

// reducer
        cfm.set("reducer_input",input_reducer.getText());
        cfm.set("reducer_ouput",output_reducer.getText());
        cfm.set("reducer_options_min",min_reducer.getText());
        cfm.set("reducer_options_max",max_reducer.getText());
        cfm.set("reducer_options_removed",removed_reducer.getText());

// extractor
        cfm.set("extractor_input_hgs",input_hgs_extractor.getText());
        cfm.set("extractor_input_tv",input_tv_extractor.getText());
        cfm.set("extractor_ouput",output_extractor.getText());
        if (chkTF_extractor.isSelected()) cfm.set("extractor_options_TF","1");
        else cfm.set("extractor_options_TF","0");
        if (chkTFxIDF_extractor.isSelected()) cfm.set("extractor_options_TFxIDF","1");
        else cfm.set("extractor_options_TFxIDF","0");
        if (chkBin_extractor.isSelected()) cfm.set("extractor_options_bin","1");
        else cfm.set("extractor_options_bin","0");

// all
        cfm.set("all_verbose",verbose.getText());
        cfm.set("all_logfile",logfile.getText());
        if (aktiv_ngrams.isSelected()) cfm.set("aktiv_ngrams","1");
        else cfm.set("aktiv_ngrams","0");
        if (aktiv_words.isSelected()) cfm.set("aktiv_words","1");
        else cfm.set("aktiv_words","0");
        if (aktiv_template.isSelected()) cfm.set("aktiv_template","1");
        else cfm.set("aktiv_template","0");
        if (aktiv_reducer.isSelected()) cfm.set("aktiv_reducer","1");
        else cfm.set("aktiv_reducer","0");
        if (aktiv_extractor.isSelected()) cfm.set("aktiv_extractor","1");
        else cfm.set("aktiv_extractor","0");

      } catch (Exception e) {System.out.println("error save config: "+e.getMessage());}
    }
    } catch (Exception e) {} //do nothing

    // SAVE
  }//GEN-LAST:event_saveActionPerformed

  public int verb=0;
  public somlib.textrepresentation.Logfile l;

  private void runActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runActionPerformed
  String oldTitle = getTitle();
  setTitle(oldTitle+" [Running]");

  try {
    java.io.File logf = null; // logfile
    if (logfile.getText().compareTo("") != 0) { // bei logfile steht etwas
      logf = new java.io.File(logfile.getText());
      if (!logf.exists()) { // file existiert noch nicht, anlegen?
        Object[] options = {"Yes", "No"};
        int n = javax.swing.JOptionPane.showOptionDialog(this,"Logfile does not exists. Create new file?", "Create File", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
          if (n == javax.swing.JOptionPane.YES_OPTION) try {
            java.io.File dirOfLogf = new java.io.File(logf.toString().substring(0,logf.toString().lastIndexOf(java.io.File.separator)));
            dirOfLogf.mkdirs(); logf.createNewFile();
          } catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, "Cannot create file.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
            throw new java.io.IOException();
          }
          else throw new java.io.IOException();
      }
    }
    try {
      verb = (new Integer(verbose.getText())).intValue();
      if ((verb>3) || (verb<0)) {
        throw new java.io.IOException();
      }
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, "Verbose must be in [0..3].", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }

    try {
      if (logfile.getText().compareTo("") != 0)  // bei logfile steht etwas
        l = new somlib.textrepresentation.Logfile(logfile.getText());
      else l=null;

      if (aktiv_ngrams.isSelected()) ngrams();
      if (aktiv_words.isSelected()) words();
      if (aktiv_template.isSelected()) template();
      if (aktiv_reducer.isSelected()) reducer();
      if (aktiv_extractor.isSelected()) extractor();

      if(l!=null) l.close();
      setTitle(oldTitle);
      javax.swing.JOptionPane.showMessageDialog(this, "Succesfully executed.", "Information", javax.swing.JOptionPane.INFORMATION_MESSAGE);

    } catch (Exception e) { setTitle(oldTitle); if(l!=null) l.close();// hier nichts machen, fehler wurde schon behandelt.
    }
  } catch (Exception e) { setTitle(oldTitle); if(l!=null) l.close();// hier nichts machen, fehler wurde schon behandelt.
  }
  // RUN
  }//GEN-LAST:event_runActionPerformed

  private void ngrams() throws java.io.IOException {
    int sizeN = 0;
    try {
      sizeN = (new Integer(sizeN_ngrams.getText())).intValue();
      if (sizeN<=0) {
        throw new java.io.IOException();
      }
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, "Incorrect Value for N (n-grams).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.io.File indir3 = null;
    if (input_ngrams.getText().compareTo("") != 0) { // bei input steht etwas
      indir3 = new java.io.File(input_ngrams.getText());
      if (!indir3.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "NGrams input directory does not exist.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();;
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "NGrams input directory missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.io.File outdir3 = null;
    if (output_ngrams.getText().compareTo("") != 0) { // bei output steht etwas
      outdir3 = new java.io.File(output_ngrams.getText());
      if (!outdir3.exists()) { // file existiert noch nicht, anlegen?
        Object[] options = {"Yes", "No"};
        int n = javax.swing.JOptionPane.showOptionDialog(this,"NGrams output directory does not exists. Create new directory?", "Create Directory", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
          if (n == javax.swing.JOptionPane.YES_OPTION) try {outdir3.mkdirs();} catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, "Cannot create directory.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
            throw new java.io.IOException();
          }
          else throw new java.io.IOException();
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "NGrams output directory missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    try {
      if(l != null) {
        l.append("  Start: NGrams");
        l.append("    Params:");
        if (spaces_ngrams.isSelected()) l.append("      spaces: true");
        else l.append("      spaces: false");
        if (numbers_ngrams.isSelected()) l.append("      numbers: true");
        else l.append("      numbers: false");
        l.append("      size N: " + sizeN);
        l.append("      input: " + input_ngrams.getText());
        l.append("      output: "+output_ngrams.getText());
        l.append("      suffix: .idv");
        l.append("    Params end.");
      }
      java.io.File f1 = new java.io.File(input_ngrams.getText());
      java.io.File[] fili1 = f1.listFiles();
      somlib.textrepresentation.parser.NGrams ngr = new somlib.textrepresentation.parser.NGrams(sizeN,numbers_ngrams.isSelected(),spaces_ngrams.isSelected());
      ngr.createFiles(fili1,output_ngrams.getText(),(byte) verb,l,false,".idv");
      if(l != null)
        l.append("  End: NGrams");
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, e.getMessage(), "NGrams Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      if (l != null) {
        l.append("Error: "+e.getMessage());
      }
      throw new java.io.IOException("Error: "+e.getMessage());
    }
  } // ngrams

  private void words() throws java.io.IOException {
    java.io.File indir4 = null;
    if (input_words.getText().compareTo("") != 0) { // bei input steht etwas
      indir4 = new java.io.File(input_words.getText());
      if (!indir4.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "Words input directory does not exist.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();;
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Words input directory missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.io.File outdir4 = null;
    if (output_words.getText().compareTo("") != 0) { // bei output steht etwas
      outdir4 = new java.io.File(output_words.getText());
      if (!outdir4.exists()) { // file existiert noch nicht, anlegen?
        Object[] options = {"Yes", "No"};
        int returnVal = javax.swing.JOptionPane.showOptionDialog(this,"Words output directory does not exists. Create new directory?", "Create Directory", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
          if (returnVal == javax.swing.JOptionPane.YES_OPTION) try {outdir4.mkdirs();} catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, "Cannot create directory.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
            throw new java.io.IOException();
          }
          else throw new java.io.IOException();
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Words output directory missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    int minLength = 0;
    try {
      minLength = (new Integer(minLength_words.getText())).intValue();
      if (minLength<=1) {
        throw new java.io.IOException();
      }
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, "Incorrect Value for Minimum Word Length.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    try {
      if(l != null) {
        l.append("  Start: Words");
        l.append("    Params:");
        l.append("      minLength: " + minLength_words.getText());
        l.append("      input: " + input_words.getText());
        l.append("      output: "+output_words.getText());
        l.append("      suffix: .idv");
        l.append("    Params end.");
      }
      somlib.textrepresentation.parser.Words pws = new somlib.textrepresentation.parser.Words(minLength);
      java.io.File f1b = new java.io.File(input_words.getText());
      java.io.File[] fili1b = f1b.listFiles();
      pws.createFiles(fili1b,output_words.getText(),(byte) verb,l,false,".idv");
      if(l != null)
        l.append("  End: Words");
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, e.getMessage(), "Words Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      if (l != null)
        l.append("Error: "+e.getMessage());
      throw new java.io.IOException("Error: "+e.getMessage());
    }
  } // words

  private void template() throws java.io.IOException {
    java.io.File indir5 = null;
    if (input_template.getText().compareTo("") != 0) { // bei input steht etwas
      indir5 = new java.io.File(input_template.getText());
      if (!indir5.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "Create template vector input directory does not exist.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();;
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Create template vector input directory missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.util.Hashtable oldTV = null;
    java.io.File oldf = null;
    if (old_template.getText().compareTo("") != 0) {
      oldf = new java.io.File(old_template.getText());
      if (!oldf.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "Can not find 'Existing Template' (create template vector).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();
      } else {
        try {
          oldTV = somlib.textrepresentation.TemplateVector.load(old_template.getText());
        } catch (Exception e) {
          javax.swing.JOptionPane.showMessageDialog(this, "Can not load 'Existing Template' (create template vector).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
          throw new java.io.IOException();
        }
      }
    }
    java.io.File outdir5 = null;
    if (output_template.getText().compareTo("") == 0) {
      javax.swing.JOptionPane.showMessageDialog(this, "Create template vector output file missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    try {
      if(l != null) {
        l.append("  Start: CreateTemplateVector");
        l.append("    Params:");
        l.append("      existing template: " + old_template.getText());
        l.append("      input: " + input_template.getText());
        l.append("      output: "+ output_template.getText());
        l.append("    Params end.");
      }
      java.io.File f3 = new java.io.File(input_template.getText());
      java.io.File[] fili3 = f3.listFiles();
      somlib.textrepresentation.TemplateVector.store(output_template.getText(),somlib.textrepresentation.CreateTemplate.merge(fili3,oldTV,(byte) verb,l));
      if(l != null)
        l.append("  End: CreateTemplateVector");
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, e.getMessage(), "Create Template Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      if (l != null)
        l.append("Error: "+e.getMessage());
      throw new java.io.IOException("Error: "+e.getMessage());
    }
  } // template

  private void reducer() throws java.io.IOException {
// REDUCER
    java.io.File indir6 = null;
    if (input_reducer.getText().compareTo("") != 0) { // bei input steht etwas
      indir6 = new java.io.File(input_reducer.getText());
      if (!indir6.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "Reducer input file does not exist.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();;
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Reducer input file missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.util.Hashtable tv = null;
    java.io.File tvf = null;
    if (input_reducer.getText().compareTo("") != 0) {
      tvf = new java.io.File(input_reducer.getText());
      try {
        tv = somlib.textrepresentation.TemplateVector.load(input_reducer.getText());
      } catch (Exception e) {
        javax.swing.JOptionPane.showMessageDialog(this, "Can not load 'Template Vector' (reducer).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();
      }
    }
    java.io.File outdir6 = null;
    if (output_reducer.getText().compareTo("") == 0) {
      javax.swing.JOptionPane.showMessageDialog(this, "Reducer output file missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    double minD =0.0;
    try {
      minD = (new Double(min_reducer.getText())).doubleValue();
      if ((minD<0.0) || (minD>1.0)) {
        throw new java.io.IOException();
      }
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, "Minimum must be in [0.0-1.0] (reducer).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    double maxD =0.0;

// EDITED elias 31.3.2000
      maxD = (new Double(max_reducer.getText())).doubleValue();
      if (maxD>1.0) {
    Object[] options = { "OK", "CANCEL" };
        int selectedValue =  javax.swing.JOptionPane.showOptionDialog(null, "Maximum greater than 100% (reducer). Click OK to continue.", "Warning", javax.swing.JOptionPane.DEFAULT_OPTION, javax.swing.JOptionPane.WARNING_MESSAGE, null, options, options[0]);
           if (selectedValue==1) throw new java.io.IOException();
      }
// END EDITED

    if (minD >= maxD) {
      javax.swing.JOptionPane.showMessageDialog(this, "Maximum must be smaller than Minimum (reducer).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    try {
      if(l != null) {
        l.append("  Start: Reducer");
        l.append("    Params:");
        l.append("      input: " + input_reducer.getText());
        l.append("      output: "+ output_reducer.getText());
        l.append("      min: " + min_reducer.getText());
        l.append("      max: "+ max_reducer.getText());
        l.append("      removed: " + removed_reducer.getText());
        l.append("    Params end.");
      }
      java.util.Hashtable redTv = new java.util.Hashtable();
      if (verb >1) System.out.println("$files: "+((java.lang.Integer)tv.get("$files")).intValue());
      int minCount = (int) (minD* ((java.lang.Integer)tv.get("$files")).intValue());
      int maxCount = (int) (maxD* ((java.lang.Integer)tv.get("$files")).intValue());
      if (removed_reducer.getText().compareTo("")!=0) {
        redTv = somlib.textrepresentation.Reducer.reduce(removed_reducer.getText(), maxCount, minCount, tv, (byte) verb, l);
//        somlib.textrepresentation.TemplateVector.toTextFile(output_reducer.getText()+".tv.txt", redTv);
      } else {
        redTv = somlib.textrepresentation.Reducer.reduce(null, maxCount, minCount, tv, (byte) verb, l);
      }
      somlib.textrepresentation.TemplateVector.store(output_reducer.getText(),tv);
      if(l != null)
        l.append("  End: Reducer");
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, e.getMessage(), "Reducer Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      if (l != null)
        l.append("Error: "+e.getMessage());
      throw new java.io.IOException("Error: "+e.getMessage());
    }
  } // reducer

  private void extractor() throws java.io.IOException {
// EXTRACTOR
    java.io.File indir = null;
    if (input_hgs_extractor.getText().compareTo("") != 0) { // bei input steht etwas
      indir = new java.io.File(input_hgs_extractor.getText());
      if (!indir.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "Histograms directory does not exist (extractor).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();;
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Histograms directory missing (extractor).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.io.File indir2b = null;
    if (input_tv_extractor.getText().compareTo("") != 0) { // bei input steht etwas
      indir2b = new java.io.File(input_tv_extractor.getText());
      if (!indir2b.exists()) { // dir existiert nicht
        javax.swing.JOptionPane.showMessageDialog(this, "Template Vector does not exist. (extractor)", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
        throw new java.io.IOException();;
      }
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Template Vector missing (extractor).", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    java.io.File outdir = null;
    if (output_extractor.getText().compareTo("") != 0) { // bei output steht etwas
    } else {
      javax.swing.JOptionPane.showMessageDialog(this, "Extractor output file missing.", "Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      throw new java.io.IOException();
    }
    if (!chkTF_extractor.isSelected() && !chkTFxIDF_extractor.isSelected() && !chkBin_extractor.isSelected()) {
      javax.swing.JOptionPane.showMessageDialog(this, "No save type selected (extractor).", "Information", javax.swing.JOptionPane.INFORMATION_MESSAGE);
      throw new java.io.IOException();
    }
    try {
      if(l != null) {
        l.append("  Start: Extractor");
        l.append("    Params:");
        if (chkTF_extractor.isSelected()) l.append("      TF: true");
        else l.append("      TF: false");
        if (chkTFxIDF_extractor.isSelected()) l.append("      TFxIDV: true");
        else l.append("      TFxIDV: false");
        if (chkBin_extractor.isSelected()) l.append("      bin: true");
        else l.append("      bin: false");
        l.append("      input_hgs: " + input_hgs_extractor.getText());
        l.append("      input_tv: " + input_tv_extractor.getText());
        l.append("      output: "+output_extractor.getText());
        l.append("    Params end.");
      }
      java.io.File f2 = new java.io.File(input_hgs_extractor.getText());
      java.io.File[] fili2 = f2.listFiles();
      if (chkTFxIDF_extractor.isSelected()) {
        if(l != null) l.append("    making TFxIDF.");
        somlib.textrepresentation.extractor.TFxLog_NdivDF_ ext1 = new somlib.textrepresentation.extractor.TFxLog_NdivDF_();
        ext1.extract(new java.io.File(output_extractor.getText()+".tfxidf"), "vec_tfxidf", fili2,somlib.textrepresentation.TemplateVector.load(input_tv_extractor.getText()), (byte) verb,l);
         if(l != null) l.append("    done TFxIDF.");
      }
      if (chkTF_extractor.isSelected()) {
        if(l != null) l.append("    making TF.");
        somlib.textrepresentation.extractor.TF ext2 = new somlib.textrepresentation.extractor.TF();
        ext2.extract(new java.io.File(output_extractor.getText()+".tf"), "vec_tf", fili2,somlib.textrepresentation.TemplateVector.load(input_tv_extractor.getText()), (byte) verb,l);
        if(l != null) l.append("    done TF.");
      }
      if (chkBin_extractor.isSelected()) {
        if(l != null) l.append("    making bin.");
        somlib.textrepresentation.extractor.Binary ext3 = new somlib.textrepresentation.extractor.Binary();
        ext3.extract(new java.io.File(output_extractor.getText()+".bin"), "vec_bin", fili2,somlib.textrepresentation.TemplateVector.load(input_tv_extractor.getText()), (byte) verb,l);
        if(l != null) l.append("    done bin.");
      }
        if(l != null) l.append("  End: Extractor");
    } catch (Exception e) {
      javax.swing.JOptionPane.showMessageDialog(this, e.getMessage(), "Extractor Error", javax.swing.JOptionPane.ERROR_MESSAGE);
      if (l != null)
        l.append("Error: "+e.getMessage());
      throw new java.io.IOException("Error: "+e.getMessage());
    }
  } // extractor





  private void sIn_ngramsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sIn_ngramsActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      input_ngrams.setText(file.toString());
     }
  }//GEN-LAST:event_sIn_ngramsActionPerformed

  private void sOut_ngramsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sOut_ngramsActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      output_ngrams.setText(file.toString());
     }
  }//GEN-LAST:event_sOut_ngramsActionPerformed

  private void sIn_wordsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sIn_wordsActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      input_words.setText(file.toString());
     }
  }//GEN-LAST:event_sIn_wordsActionPerformed

  private void sOut_wordsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sOut_wordsActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      output_words.setText(file.toString());
     }
  }//GEN-LAST:event_sOut_wordsActionPerformed

  private void sIn_templateActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sIn_templateActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      input_template.setText(file.toString());
     }
  }//GEN-LAST:event_sIn_templateActionPerformed

  private void sOut_templateActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sOut_templateActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      output_template.setText(file.toString());
     }
  }//GEN-LAST:event_sOut_templateActionPerformed

  private void sOld_templateActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sOld_templateActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      old_template.setText(file.toString());
     }
  }//GEN-LAST:event_sOld_templateActionPerformed

  private void sRem_reducerActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sRem_reducerActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      removed_reducer.setText(file.toString());
     }
  }//GEN-LAST:event_sRem_reducerActionPerformed

  private void sOut_reducerActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sOut_reducerActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      output_reducer.setText(file.toString());
     }
  }//GEN-LAST:event_sOut_reducerActionPerformed

  private void sIn_reducerActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sIn_reducerActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      input_reducer.setText(file.toString());
     }
  }//GEN-LAST:event_sIn_reducerActionPerformed

  private void sHgs_extractorActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sHgs_extractorActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      input_hgs_extractor.setText(file.toString());
     }
  }//GEN-LAST:event_sHgs_extractorActionPerformed

  private void sTv_extractorActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sTv_extractorActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      input_tv_extractor.setText(file.toString());
     }
  }//GEN-LAST:event_sTv_extractorActionPerformed

  private void sOutActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sOutActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      output_extractor.setText(file.toString());
     }
  }//GEN-LAST:event_sOutActionPerformed

  private void sLogActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sLogActionPerformed
    fc.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
      java.io.File file = fc.getSelectedFile();
      logfile.setText(file.toString());
     }
  }//GEN-LAST:event_sLogActionPerformed

  private void quitActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitActionPerformed
    System.exit(0);
  }//GEN-LAST:event_quitActionPerformed

  private void helpActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpActionPerformed
    h_all.move(this);
    h_all.show();
  }//GEN-LAST:event_helpActionPerformed



  private void help_ngramsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_help_ngramsActionPerformed
    h_ngrams.move(this);
    h_ngrams.show();
  }//GEN-LAST:event_help_ngramsActionPerformed

  private void help_wordsActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_help_wordsActionPerformed
    h_words.move(this);
    h_words.show();
  }//GEN-LAST:event_help_wordsActionPerformed

  private void help_templateActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_help_templateActionPerformed
    h_template.move(this);
    h_template.show();
  }//GEN-LAST:event_help_templateActionPerformed

  private void help_reducerActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_help_reducerActionPerformed
    h_reducer.move(this);
    h_reducer.show();
  }//GEN-LAST:event_help_reducerActionPerformed

  private void help_extractorActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_help_extractorActionPerformed
    h_extractor.move(this);
    h_extractor.show();
  }//GEN-LAST:event_help_extractorActionPerformed


  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm


// Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel jPanel27;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel9;
  private javax.swing.JPanel jPanel123;
  private javax.swing.JPanel jPanel62;
  private javax.swing.JPanel jPanel11;
  private javax.swing.JPanel jPanel10;
  private javax.swing.JPanel jPanel44;
  private javax.swing.JPanel jPanel43;
  private javax.swing.JPanel jPanel92;
  private javax.swing.JPanel jPanel93;
  private javax.swing.JPanel jPanel94;
  private javax.swing.JPanel jPanel95;
  private javax.swing.JLabel jLabel20;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JLabel jLabel31;
  private javax.swing.JLabel jLabel32;
  private javax.swing.JLabel jLabel33;
  private javax.swing.JLabel jLabel34;
  private javax.swing.JPanel jPanel96;
  private javax.swing.JPanel jPanel98;
  private javax.swing.JPanel jPanel86;
  private javax.swing.JPanel jPanel89;
  private javax.swing.JPanel jPanel91;
  private javax.swing.JPanel jPanel97;
  private javax.swing.JCheckBox aktiv_ngrams;
  private javax.swing.JLabel jLabel11;
  private javax.swing.JLabel jLabel36;
  private javax.swing.JPanel jPanel84;
  private javax.swing.JPanel jPanel85;
  private javax.swing.JLabel jLabel21;
  private javax.swing.JTextField input_ngrams;
  private javax.swing.JButton sIn_ngrams;
  private javax.swing.JPanel jPanel87;
  private javax.swing.JPanel jPanel88;
  private javax.swing.JLabel jLabel22;
  private javax.swing.JTextField output_ngrams;
  private javax.swing.JButton sOut_ngrams;
  private javax.swing.JPanel jPanel14;
  private javax.swing.JPanel jPanel16;
  private javax.swing.JPanel jPanel19;
  private javax.swing.JPanel jPanel17;
  private javax.swing.JLabel jLabel23;
  private javax.swing.JTextField sizeN_ngrams;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JPanel jPanel20;
  private javax.swing.JPanel jPanel90;
  private javax.swing.JLabel jLabel24;
  private javax.swing.JPanel jPanel15;
  private javax.swing.JCheckBox numbers_ngrams;
  private javax.swing.JCheckBox spaces_ngrams;
  private javax.swing.JButton help_ngrams;
  private javax.swing.JPanel jPanel8;
  private javax.swing.JPanel jPanel79;
  private javax.swing.JPanel jPanel110;
  private javax.swing.JPanel jPanel113;
  private javax.swing.JPanel jPanel121;
  private javax.swing.JPanel jPanel122;
  private javax.swing.JCheckBox aktiv_words;
  private javax.swing.JLabel jLabel14;
  private javax.swing.JLabel jLabel41;
  private javax.swing.JPanel jPanel108;
  private javax.swing.JPanel jPanel109;
  private javax.swing.JLabel jLabel42;
  private javax.swing.JTextField input_words;
  private javax.swing.JButton sIn_words;
  private javax.swing.JPanel jPanel111;
  private javax.swing.JPanel jPanel112;
  private javax.swing.JLabel jLabel43;
  private javax.swing.JTextField output_words;
  private javax.swing.JButton sOut_words;
  private javax.swing.JPanel jPanel116;
  private javax.swing.JLabel jLabel46;
  private javax.swing.JTextField minLength_words;
  private javax.swing.JButton help_words;
  private javax.swing.JPanel jPanel99;
  private javax.swing.JPanel jPanel100;
  private javax.swing.JPanel jPanel65;
  private javax.swing.JPanel jPanel68;
  private javax.swing.JPanel jPanel72;
  private javax.swing.JPanel jPanel69;
  private javax.swing.JCheckBox aktiv_template;
  private javax.swing.JLabel jLabel12;
  private javax.swing.JLabel jLabel37;
  private javax.swing.JPanel jPanel63;
  private javax.swing.JPanel jPanel64;
  private javax.swing.JLabel jLabel29;
  private javax.swing.JTextField input_template;
  private javax.swing.JButton sIn_template;
  private javax.swing.JPanel jPanel66;
  private javax.swing.JPanel jPanel67;
  private javax.swing.JLabel jLabel30;
  private javax.swing.JTextField output_template;
  private javax.swing.JButton sOut_template;
  private javax.swing.JPanel jPanel70;
  private javax.swing.JPanel jPanel71;
  private javax.swing.JLabel jLabel44;
  private javax.swing.JTextField old_template;
  private javax.swing.JButton sOld_template;
  private javax.swing.JButton help_template;
  private javax.swing.JPanel jPanel103;
  private javax.swing.JPanel jPanel102;
  private javax.swing.JPanel jPanel50;
  private javax.swing.JPanel jPanel53;
  private javax.swing.JPanel jPanel60;
  private javax.swing.JPanel jPanel61;
  private javax.swing.JCheckBox aktiv_reducer;
  private javax.swing.JLabel jLabel38;
  private javax.swing.JLabel jLabel13;
  private javax.swing.JPanel jPanel48;
  private javax.swing.JPanel jPanel49;
  private javax.swing.JLabel jLabel25;
  private javax.swing.JTextField input_reducer;
  private javax.swing.JButton sIn_reducer;
  private javax.swing.JPanel jPanel51;
  private javax.swing.JPanel jPanel52;
  private javax.swing.JLabel jLabel26;
  private javax.swing.JTextField output_reducer;
  private javax.swing.JButton sOut_reducer;
  private javax.swing.JPanel jPanel56;
  private javax.swing.JPanel jPanel82;
  private javax.swing.JPanel jPanel59;
  private javax.swing.JPanel jPanel54;
  private javax.swing.JPanel jPanel55;
  private javax.swing.JLabel jLabel27;
  private javax.swing.JTextField min_reducer;
  private javax.swing.JLabel jLabel28;
  private javax.swing.JTextField max_reducer;
  private javax.swing.JSeparator jSeparator8;
  private javax.swing.JPanel jPanel57;
  private javax.swing.JPanel jPanel58;
  private javax.swing.JLabel jLabel45;
  private javax.swing.JTextField removed_reducer;
  private javax.swing.JButton sRem_reducer;
  private javax.swing.JButton help_reducer;
  private javax.swing.JPanel jPanel101;
  private javax.swing.JPanel jPanel104;
  private javax.swing.JPanel jPanel23;
  private javax.swing.JPanel jPanel29;
  private javax.swing.JPanel jPanel32;
  private javax.swing.JPanel jPanel45;
  private javax.swing.JCheckBox aktiv_extractor;
  private javax.swing.JLabel jLabel39;
  private javax.swing.JLabel jLabel40;
  private javax.swing.JPanel jPanel18;
  private javax.swing.JPanel jPanel22;
  private javax.swing.JLabel jLabel15;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JTextField input_hgs_extractor;
  private javax.swing.JButton sHgs_extractor;
  private javax.swing.JLabel jLabel16;
  private javax.swing.JPanel jPanel21;
  private javax.swing.JTextField input_tv_extractor;
  private javax.swing.JButton sTv_extractor;
  private javax.swing.JPanel jPanel26;
  private javax.swing.JPanel jPanel28;
  private javax.swing.JPanel jPanel25;
  private javax.swing.JLabel jLabel17;
  private javax.swing.JTextField output_extractor;
  private javax.swing.JButton sOut;
  private javax.swing.JPanel jPanel30;
  private javax.swing.JPanel jPanel31;
  private javax.swing.JLabel jLabel18;
  private javax.swing.JCheckBox chkTF_extractor;
  private javax.swing.JCheckBox chkTFxIDF_extractor;
  private javax.swing.JCheckBox chkBin_extractor;
  private javax.swing.JButton help_extractor;
  private javax.swing.JPanel jPanel24;
  private javax.swing.JPanel jPanel106;
  private javax.swing.JPanel jPanel107;
  private javax.swing.JPanel jPanel83;
  private javax.swing.JPanel jPanel105;
  private javax.swing.JPanel jPanel80;
  private javax.swing.JPanel jPanel12;
  private javax.swing.JPanel jPanel13;
  private javax.swing.JLabel jLabel6;
  private javax.swing.JTextField logfile;
  private javax.swing.JButton sLog;
  private javax.swing.JLabel jLabel5;
  private javax.swing.JTextField verbose;
  private javax.swing.JLabel jLabel35;
  private javax.swing.JButton open;
  private javax.swing.JButton save;
  private javax.swing.JButton help;
  private javax.swing.JButton run;
  private javax.swing.JButton quit;
// End of variables declaration//GEN-END:variables


  public static void main(java.lang.String[] args) {
    new Parser ().show ();
  }

}
